systemheader:(AR    )#                                                  AR     1
####################################################################### AR     2
##      Copyright (C) 2000, The Xtal System, The University of        # AR     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # AR     4
## Distributed under the GNU General Public Licence as published by   # AR     5
## the Free Software Foundation, in the hope that it will be useful   # AR     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # AR     7
## for more details.                                                  # AR     8
##                                                                    # AR     9
##                        *** ADDREF ***                              # AR    10
##                                                                    # AR    11
##   ADDREF ADDS REFLECTION DATA TO THE BDF. HKL'S MAY BE ENTERED     # AR    12
##   FROM HKL LINES OR ANOTHER BDF. THE DATA MAY BE TRANSFORMED       # AR    13
##   INTO ANY COMBINATION OF FREL, FSQD OR IREL.                      # AR    14
##                                                                    # AR    15
####################################################################### AR    16
#                                                                       AR    17
include:(XMACRO)#                                                       AR    18
#                                                                       AR    19
macro:(ifpos:,IF($1>small:))#                                           AR    20
macro:(idnm:,QX($1+1))#                                                 AR    21
macro:(pnti:,QX($1+2))#                                                 AR    22
macro:(pnto:,QX($1+3))#                                                 AR    23
macro:(err:, QX($1+4))#                                                 AR    24
macro:(pmin:,QX($1+5))#                                                 AR    25
macro:(pmax:,QX($1+6))#                                                 AR    26
macro:(mxwd40c:,incr:(arith:(39,/,mxchwd:)))#                           AR    27
#                                                                       AR    28
extrude:(ARCOMN)#                                                       AR    29
string:(AR023,132)#                    Table of lrrefl mnemonics        AR    30
string:(AR055,132)#                    Refl print heading               AR    31
REAL COUNT(7),PRINT#                   Refl type, counts                AR    32
REAL DIRN(50)#                         Table of lrrefl id no.s          AR    33
REAL DMIN#                             Minimum allowed d-spacing        AR    34
REAL DSNM#                             Data set number                  AR    35
REAL EPSLMN#                           Minimum epsilon                  AR    36
REAL EPSLMX#                           Maximum epsilon                  AR    37
REAL HKLMAX(3)#                        Max hkl in output file           AR    38
REAL HKLMIN(3)#                        Min hkl in output file           AR    39
REAL HNEG(3)#                          Hkl negative limits              AR    40
REAL HPOS(3)#                          Hkl positive limits              AR    41
REAL HX#                               Maximum h magnitude              AR    42
REAL JMAX#                             Maximum allowed rcode            AR    43
REAL KX#                               Maximum k magnitude              AR    44
REAL LAMBDA#                           Radiation wavelength             AR    45
REAL LX#                               Maximum l magnitude              AR    46
REAL MONOPF#                           Perfection of monochromator      AR    47
REAL POLFR#                            Polarization of source beam      AR    48
REAL PPFAC#                            Source polariz. factor           AR    49
REAL MONO2T#                           Cos(2theta) monochromator        AR    50
REAL MULMAX#                           Maximum multiplicity             AR    51
REAL MULMIN#                           Minimum multiplicity             AR    52
REAL OUTMAX(2)#                        Statistics                       AR    53
REAL OUTMIN(2)#                        Statistics                       AR    54
REAL PRCMAX#                           Phase restr code max             AR    55
REAL PRCMIN#                           Phase restr code min             AR    56
REAL RM(9)#                            Recip metric tensor              AR    57
REAL SGRPMX#                           Maximum scale group              AR    58
REAL SGRPMN#                           Minimum scale group              AR    59
REAL SIGMAX(2)#                        Statistics                       AR    60
REAL SIGMIN(2)#                        Statistics                       AR    61
REAL SMAX#                             Maximum stol                     AR    62
REAL STOLMX#                           Max stol in output file          AR    63
REAL STOLMN#                           Min stol                         AR    64
REAL TM(9)#                            Transformation matrix            AR    65
REAL VOL#                              Unit cell volume in a**3         AR    66
#                                                                       AR    67
INTEGER EPSL#                          Epsilon                          AR    68
INTEGER FFAC#                          Form factor flag                 AR    69
INTEGER FILE(12)#                      File numbers                     AR    70
INTEGER GENALL#                        Flag to generate whole sphere    AR    71
INTEGER IBAY#                          Bayesian corr flag               AR    72
INTEGER ICNT#                          Centricity ac=0  c=1             AR    73
INTEGER IFRIED#                        Friedel pair signal 1/2          AR    74
INTEGER IGEN#                          Generate hkl flag                AR    75
INTEGER INDAT#                         Input data                       AR    76
INTEGER INEU#                          Neutron or xray data             AR    77
INTEGER IOUT#                          Output f,f2,or i                 AR    78
INTEGER IPHI#                          Phi in degrees flag              AR    79
INTEGER IREL(51)#                      Indexpkt pointers ar05-6         AR    80
INTEGER IRLP#                          1/lp calculation method          AR    81
INTEGER ISTOP#                         Current end of memory            AR    82
INTEGER ITRF#                          Transformation flag              AR    83
INTEGER LIMITS#                        Maxhkl preservation flag         AR    84
INTEGER LIST#                          Listing flag                     AR    85
INTEGER LPINS#                         Signal to place 1/lp in bdf      AR    86
INTEGER MARK(12)#                      Item buffer pointers             AR    87
INTEGER MARKOT#                        Ipt output-only items            AR    88
INTEGER MARK0#                         Bufpt replica bdf                AR    89
INTEGER MARK1#                         Bufpt items                      AR    90
INTEGER MARK2#                         Bufpt symmetry matrices          AR    91
INTEGER MARK3#                         Bufpt form factors               AR    92
INTEGER MARK5#                         Output packet pointers           AR    93
INTEGER MK#                            Pointer into item array          AR    94
INTEGER MXITEM#                        Maximum items in lrrefl:         AR    95
INTEGER NAR023#                        Number of chars in ar023         AR    96
INTEGER NAR055#                        No. chars in refl print head     AR    97
INTEGER NFIL#                          Number of files                  AR    98
INTEGER NPUTPK#                        Input pkt pointer aa05/aa06      AR    99
INTEGER NSCGRP#                        Number of scale groups           AR   100
INTEGER OUTDAT#                        Output data                      AR   101
INTEGER OABS#                          Only output systm absnt reflns   AR   102
INTEGER PAKPT(12)#                     Packet pointers for files        AR   103
INTEGER PSIZHO#                        Save lrrefl: pkt size            AR   104
INTEGER PSIZE#                         Various pkt sizes                AR   105
INTEGER PSIZO#                         Final lrrefl pkt size            AR   106
INTEGER SABS#                          Sys abs hkl flag                 AR   107
INTEGER STOP1#                         End of item array                AR   108
#                                                                       AR   109
COMMON/COMCAR/ AR023,AR055#                                             AR   110
#                                                                       AR   111
COMMON/COMIAR/ EPSL,FFAC,FILE,IBAY,ICNT,IFRIED,IOUT,ISTOP,#             AR   112
IGEN,ITRF,MARK,MARKOT,MARK0,MARK1,MARK2,NSCGRP,#                        AR   113
MARK3,MARK5,MXITEM,MK,NAR023,NAR055,NFIL,NPUTPK,PAKPT,#                 AR   114
PSIZHO,PSIZE,PSIZO,SABS,STOP1,OABS,GENALL,#                             AR   115
LIMITS,LIST,IRLP,INEU,INDAT,OUTDAT,IPHI,IREL#                           AR   116
#                                                                       AR   117
COMMON/COMFAR/ COUNT,DIRN,DMIN,DSNM,HKLMAX,HX,#                         AR   118
JMAX,KX,LX,PRINT,RM,PRCMAX,PRCMIN,PPFAC,#                               AR   119
SMAX,STOLMX,TM,EPSLMX,EPSLMN,HKLMIN,MULMAX,MULMIN,#                     AR   120
OUTMAX,OUTMIN,SIGMAX,SIGMIN,SGRPMX,SGRPMN,#                             AR   121
HNEG,HPOS,STOLMN,MONO2T,MONOPF,LAMBDA,LPINS,VOL,POLFR#                  AR   122
endext:#                                                                AR   123
#                                                                       AR   124
systemheader:(AR00)#                   Add refln data to bdf            AR00   1
##############################################################          AR00   2
#                                                            #          AR00   3
#                          AR00                              #          AR00   4
#                                                            #          AR00   5
##############################################################          AR00   6
SUBROUTINE AR00#                       G. davenport 1982                AR00   7
include:(AACOMN)#                      S.r. hall 1984                   AR00   8
include:(ARCOMN)#                      N. spadaccini 1990               AR00   9
#                                                                       AR00  10
FILEXT(IOUNIT(3))='XX1'#               Define default scratch file      AR00  11
#                                                                       AR00  12
CALL AR01#                             Input control lines & list       AR00  13
CALL AR02#                             Read bdf & create scratch        AR00  14
CALL AR03#                             Symmetry & scattering data       AR00  15
CALL AR04#                             Enter reflection files           AR00  16
CALL AR05#                             O/p bdf records                  AR00  17
#                                                                       AR00  18
RETURN#                                                                 AR00  19
END#                                                                    AR00  20
systemheader:(AR01)#                   Input control lines & list       AR01   1
##############################################################          AR01   2
#                                                            #          AR01   3
#                          AR01                              #          AR01   4
#                                                            #          AR01   5
##############################################################          AR01   6
SUBROUTINE AR01#                                                        AR01   7
include:(AACOMN)#                                                       AR01   8
include:(ARCOMN)#                                                       AR01   9
#                                                                       AR01  10
INTEGER I#                             Loop index                       AR01  11
INTEGER IDUM1,IDUM2#                   Input and output data            AR01  12
INTEGER M#                             String limit                     AR01  13
INTEGER N#                             String limit                     AR01  14
#                                                                       AR01  15
chardata:(AR011, REDUCE TRANSF LIMITS HKL C REMOVE $#                   AR01  16
HKLGEN BDFIN HKLIN)#                                                    AR01  17
chardata:(AR012,LIST FFAC SABS NMAX NOLP FRIE SIGF NOBA DSET OABS $#    AR01  18
NOFF BAYE )#                                                            AR01  19
chardata:(AR013," List data for all reflections           ")#           AR01  20
chardata:(AR014," Remove sys abs reflections              ")#           AR01  21
chardata:(AR015," Include form factors in lrrefl          ")#           AR01  22
chardata:(AR016," ITOF  FTOI  ITOF2 F2TOI F2TOF FTOF2 NOCON ")#         AR01  23
chardata:(AR017," Requested data conversion               ")#           AR01  24
chardata:(AR018," Lorentz-Polarization method             ")#           AR01  25
chardata:(AR019," yes no  none-Xray neutron")#                          AR01  26
chardata:(AR01A, ADDREF CONTROL PARAMETERS)#                            AR01  27
chardata:(AR01B," RLP1 RLP2 RLP3 RLP4 RLP5 RLP6 NONE ")#                AR01  28
chardata:(AR01D," Include 1/LP in lrrefl                   ")#          AR01  29
chardata:(AR01E," Treat Friedel pairs                      ")#          AR01  30
chardata:(AR01G," Apply Bayesian corr to F**2             ")#           AR01  31
intdata:(IDIR,[300,304,300,302,302,304,304,300,302,300,304,302])#       AR01  32
datastuff:#                                                             AR01  33
#                                                                       AR01  34
# SET UP INITIAL FILE BUFFERS                                           AR01  35
# ---------------------------                                           AR01  36
#                                                                       AR01  37
IOMARK(1)=QXSTR#                       Replica file buffer              AR01  38
IOMARK(2)=IOMARK(1)+bdfbuf:#           Output file buffer               AR01  39
IOMARK(3)=IOMARK(2)+bdfbuf:#           Scratch file buffer              AR01  40
incrqx:(ISTOP,IOMARK(3)+bdfbuf:,AR0101)# End of current qx              AR01  41
DO I=1,7; COUNT(I)=0.#                 Clear counts of rcodes           AR01  42
readwpkt:(1,1,IDUM1,IDUM2,0)#          Read packet                      AR01  43
#                                                                       AR01  44
# GET ADDREF PARAMETERS                                                 AR01  45
# ---------------------                                                 AR01  46
#                                                                       AR01  47
DSNM=1000.#                            Default data set 1               AR01  48
LIST=no:;PRINT=10.5#                   Default no listing               AR01  49
FFAC=yes:#                             Default no ff insertion          AR01  50
SABS=no:#                              Default remove sys abs hkl       AR01  51
OABS=no:#                              Default not absent reflns        AR01  52
LIMITS=no:#                            Default replace maxhkl data      AR01  53
LPINS=yes:#                            Default 1/lp to bdf              AR01  54
IFRIED=1#                              Do not treat friedel pairs       AR01  55
IBAY=no:#                              Apply bayes. to f**2             AR01  56
#                                                                       AR01  57
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over fields                 AR01  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR01  59
ifch:(BUFIN(I))#                       If character field               AR01  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR01  61
stringlim:(I,M,N)#                     Get string limits                AR01  62
compchar:(CHRIN,M,AR012,1,4,5,NAR012,N)# Identify string                AR01  63
IF(N==1)#                              List option                      AR01  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR01  65
LIST=yes:#                             Yes to listing                   AR01  66
IF(BUFIN(I+1)>=0.0)#                   If told a number it prevails     AR01  67
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR01  68
PRINT=BUFIN(I+1)#                      Set ref pr limit                 AR01  69
I=I+1#                                 Advance the field                AR01  70
LIST=no:#                              Make the count control           AR01  71
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR01  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR01  73
ELSE IF(N==2) FFAC=yes:#               Insert ff                        AR01  74
ELSE IF(N==3) SABS=yes:#               Leave in sys abs hkl             AR01  75
ELSE IF(N==4) LIMITS=yes:#             Preserve maxhkl in file a        AR01  76
ELSE IF(N==5) LPINS=no:#               No 1/lp in output bdf            AR01  77
ELSE IF(N==6) IFRIED=2#                Treat both of friedel pair       AR01  78
ELSE IF(N==8) IBAY=no:#                Switch off bayes. corr.          AR01  79
ELSE IF(N==9)#                         Data set number entered          AR01  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR01  81
IF(BUFIN(I+1)<1.) NEXT#                Skip if not sensible             AR01  82
I=I+1; DSNM=1000.*BUFIN(I)#            Store the dataset number         AR01  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR01  84
ELSE IF(N==10)#                        Only output sys abs hkl          AR01  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR01  86
OABS=yes: ; SABS = yes:#               Flag only sys absent             AR01  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR01  88
ELSE IF(N==11) FFAC=no:#               No interp form factors on bdf    AR01  89
ELSE IF(N==12) IBAY=yes:#              Switch bayesian correction on    AR01  90
#                                                                       AR01  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR01  92
ELSE BREAK#                            Exit loop on void                AR01  93
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR01  94
#                                                                       AR01  95
# INITIALIZE INPUT LINE QUANTITIES                                      AR01  96
# --------------------------------                                      AR01  97
#                                                                       AR01  98
IOUT=0#                                Dont change data                 AR01  99
INDAT=0#                               Reset input coeffs               AR01 100
OUTDAT=0#                              Reset output coeffs              AR01 101
IRLP=7#                                Default method 7 (none)          AR01 102
INEU=no:#                              Default xray data                AR01 103
MONO2T=-2.0#                           Default is set in ar03           AR01 104
MONOPF=0.5#                            Default monochromator perfec     AR01 105
POLFR=0.5#                             Unpolarised source beam          AR01 106
ITRF=no:#                              Default dont transf hkl          AR01 107
HX=999. ; KX=999. ; LX=999.#           Max hkl                          AR01 108
GENALL=no:#                            Do not generate whole sphere     AR01 109
DMIN=0.#                               Minimum d                        AR01 110
JMAX=5.#                               Maximum jcode                    AR01 111
SMAX=2.#                               Maximum stol                     AR01 112
SGRPMX=99. ; SGRPMN=1.; NSCGRP=1#      Set maxc min no. scale grp.      AR01 113
#                                                                       AR01 114
# READ INPUT LINES                                                      AR01 115
# ----------------                                                      AR01 116
#                                                                       AR01 117
REPEAT#                                Loop over input lines            AR01 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR01 119
readline:(AR011,NAR011)#               Read the next input line         AR01 120
IF(LINID>3) BREAK#                     Exit hklgen etc.                 AR01 121
#                                                                       AR01 122
IF(LINID==1)#                          **********reduce***********      AR01 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR01 124
ifch:(BUFIN(1))#                       Character field 1                AR01 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR01 126
stringlim:(1,M,N)#                     Get string limits                AR01 127
compchar:(CHRIN,M,AR016,2,5,6,NAR016,N)# Identify string                AR01 128
IF(N==0) iquit:(AR0102)#               Nonsense                         AR01 129
ELSE IF(N!=7)#                         If not the default               AR01 130
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR01 131
IOUT=N#                                Desired data conversion          AR01 132
INDAT=IDIR(N)+NINT(DSNM)#              Input f,f2,i                     AR01 133
OUTDAT=IDIR(N+6)+NINT(DSNM)#           Output f,f2,i                    AR01 134
IF(N<5) IRLP=2#                        Dflt for desired conversion      AR01 135
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR01 136
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR01 137
ifch:(BUFIN(2))#                       Character field 2                AR01 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR01 139
stringlim:(2,M,N)#                     Get string limits                AR01 140
compchar:(CHRIN,M,AR01B,2,4,5,NAR01B,N)# Identify string                AR01 141
IF(N!=0) IRLP=N#                       1/lp method                      AR01 142
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR01 143
ifnm:(BUFIN(3)) MONO2T=BUFIN(3)#       2theta monochromator             AR01 144
ifnm:(BUFIN(4)) MONOPF=BUFIN(4)#       Monochromator perfection         AR01 145
ifnm:(BUFIN(5)) POLFR =BUFIN(5)#       Fraction of source polarizatio   AR01 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR01 147
#                                                                       AR01 148
ELSE IF(LINID==2)#                     ***********transf***********     AR01 149
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR01 150
DO I=1,9#                              Loop over fields                 AR01 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR01 152
ifnm:(BUFIN(I)) TM(I)=BUFIN(I)#        Numeric field                    AR01 153
ELSE iquit:(AR0103)#                   Bad field                        AR01 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR01 155
ITRF=yes:#                             Transform hkl                    AR01 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR01 157
#                                                                       AR01 158
ELSE IF(LINID==3)#                     ************limits**********     AR01 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR01 160
ifnm:(BUFIN(1)) HX=BUFIN(1)+0.5#       Max h                            AR01 161
ifnm:(BUFIN(2)) KX=BUFIN(2)+0.5#       Max k                            AR01 162
ifnm:(BUFIN(3)) LX=BUFIN(3)+0.5#       Max l                            AR01 163
ifpos:(BUFIN(4)) SMAX=BUFIN(4)#        Max stol                         AR01 164
ifpos:(BUFIN(5)) DMIN=BUFIN(5)#        Minimum d                        AR01 165
ifpos:(BUFIN(6)) JMAX=BUFIN(6)+0.5#    Max jcode                        AR01 166
ifpos:(BUFIN(7)) SGRPMX=BUFIN(7)#      Maximum scale grps               AR01 167
ifpos:(BUFIN(8)) SGRPMN=BUFIN(8)#      Minimum scale grps               AR01 168
ifch:(BUFIN(9))  GENALL=yes:#          Sphere requested                 AR01 169
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR01 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR01 171
#                                                                       AR01 172
#   PRINT CONTROL SUMMARY                                               AR01 173
#   ---------------------                                               AR01 174
#                                                                       AR01 175
writeline:(1,AR01A,NAR01A,3,3)#        "addref control param"           AR01 176
movechar:(AR019,14,CHROT,2,25,1)#      Underline                        AR01 177
writeline:(0,0,0,1,3)#                 Write it                         AR01 178
IF(LIST==yes:)#                        If listing desired               AR01 179
movechar:(AR019,2,AR013,35,4,0)#       "yes"                            AR01 180
ELSE#                                  Default listing                  AR01 181
movechar:(AR019,6,AR013,35,4,0)#       "no"                             AR01 182
writeline:(0,AR013,NAR013,3,3)#        Tell user                        AR01 183
IF(IBAY==yes:)movechar:(AR019,2,AR01G,35,4,0)# Insert yes in mess       AR01 184
ELSE          movechar:(AR019,6,AR01G,35,4,0)# Insert no in mess        AR01 185
writeline:(0,AR01G,NAR01G,3,3)#        Print message                    AR01 186
IF (OABS==no:)#                                                         AR01 187
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR01 188
IF(SABS==no:)#                         If removal desired               AR01 189
movechar:(AR019,2,AR014,35,4,0)#       "yes"                            AR01 190
ELSE#                                  Leave them in                    AR01 191
movechar:(AR019,6,AR014,35,4,0)#       "no"                             AR01 192
writeline:(0,AR014,NAR014,3,3)#        Tell user                        AR01 193
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR01 194
ELSE writeline:(0,AR014,NAR014,3,3)#   Only systematic absences         AR01 195
IF(FFAC==yes:)#                        Ff required                      AR01 196
movechar:(AR019,2,AR015,35,4,0)#       "yes"                            AR01 197
ELSE#                                  No insertion                     AR01 198
movechar:(AR019,6,AR015,35,4,0)#       "no"                             AR01 199
writeline:(0,AR015,NAR015,3,3)#        Tell user                        AR01 200
N=6*(IOUT-1)+2#                        Point to data conversion         AR01 201
IF(IOUT<=0) N=38#                      No conversion                    AR01 202
movechar:(AR016,N,AR017,35,5,0)#       Tell conversion type             AR01 203
writeline:(0,AR017,NAR017,3,3)#        Write conversion type            AR01 204
IF(IRLP<7)#                            If 1/lp used                     AR01 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR01 206
N=5*(IRLP-1)+2#                        Point to 1/lp method             AR01 207
movechar:(AR01B,N,AR018,35,4,0)#       Move 1/lp method                 AR01 208
writeline:(0,AR018,NAR018,3,3)#        Write it                         AR01 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR01 210
IF(IOUT==no:) LPINS=no:#               So there                         AR01 211
IF(LPINS==no:)#                                                         AR01 212
movechar:(AR019,6,AR01D,35,4,0)#       "no"                             AR01 213
ELSE#                                                                   AR01 214
movechar:(AR019,2,AR01D,35,4,0)#       "yes"                            AR01 215
writeline:(0,AR01D,NAR01D,3,3)#                                         AR01 216
IF(IFRIED==1)#                                                          AR01 217
movechar:(AR019,6,AR01E,35,4,0)#       "no"                             AR01 218
ELSE#                                                                   AR01 219
movechar:(AR019,2,AR01E,35,4,0)#       "yes"                            AR01 220
writeline:(0,AR01E,NAR01E,3,3)#                                         AR01 221
#                                                                       AR01 222
IF(LINID<7) iquit:(AR0105)#            Input lines out of order         AR01 223
#                                                                       AR01 224
RETURN#                                                                 AR01 225
END#                                                                    AR01 226
systemheader:(AR02)#                   Read bdf & create scratch        AR02   1
#########################################################               AR02   2
#                                                       #               AR02   3
#                        AR02                           #               AR02   4
#                                                       #               AR02   5
#########################################################               AR02   6
SUBROUTINE AR02#                                                        AR02   7
include:(AACOMN)#                                                       AR02   8
include:(ARCOMN)#                                                       AR02   9
#                                                                       AR02  10
INTEGER I#                             Loop index                       AR02  11
INTEGER IHKL#                          Flag hkl present                 AR02  12
INTEGER IP#                            Packet size                      AR02  13
INTEGER IRCD#                          Flag rcode present               AR02  14
INTEGER J#                             Loop index                       AR02  15
INTEGER K#                             Loop index                       AR02  16
INTEGER M#                             Chrin pointer                    AR02  17
INTEGER N#                             Key in compchar                  AR02  18
#                                                                       AR02  19
chardata:(AR021, HKL C REMOVE HKLGEN BDFIN HKLIN END)#                  AR02  20
chardata:(AR022,AB)#                                                    AR02  21
chardata:(AR0A,HKL FRELSIGFFCALACALBCALIRELSIGIF2RLSGF2RCODSCGP$#       AR02  22
EXTFEVALABSFTBARPCYCPDEGRLP WGT1WGT2WGT3IFRISFRIF2FRSF2FFFRISFFR$#      AR02  23
RCDFSCGFALL SKIPFILE)#                                                  AR02  24
realdata:(FIRN,[1.,304.,305.,800.,801.,802.,300.,301.,302.,303.,#       AR02  25
308.,309.,202.,600.,201.,200.,700.,700.,204.,901.,#                     AR02  26
902.,903.,310.,311.,312.,313.,314.,315.,318.,319.])#                    AR02  27
intdata:(MXITUM,30)#                   Max items treated                AR02  28
datastuff:#                                                             AR02  29
#                                                                       AR02  30
# LOAD ITEM MNEMONICS AND LRREFL PACKET IDS IN COMMON                   AR02  31
# ---------------------------------------------------                   AR02  32
#                                                                       AR02  33
MXITEM=MXITUM#                         Set max number of items          AR02  34
movereal:(FIRN,1,DIRN,1,MXITEM,0)#     Set id no.                       AR02  35
NAR023=NAR0A#                          Set total chars                  AR02  36
movechar:(AR0A,1,AR023,1,NAR0A,0)#     Transfer lookup list             AR02  37
#                                                                       AR02  38
# INITIALIZE FILE QUANTITIES                                            AR02  39
# --------------------------                                            AR02  40
#                                                                       AR02  41
IPHI=0#                                Reset phi degrees flag           AR02  42
LINID=LINID-3#                         Reduce to current list           AR02  43
NFIL=0#                                Zero count of files              AR02  44
DO I=1,12#                             Loop over file pointers          AR02  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR02  46
MARK(I)=0 ; FILE(I)=-99#               Mark and file number             AR02  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR02  48
MARK1=ISTOP#                           Start of output item storage     AR02  49
MK=MARK1#                              Running pointer                  AR02  50
incrqx:(ISTOP,MARK1+600,AR0201)#       Get memory                       AR02  51
STOP1=ISTOP#                           End of table space               AR02  52
IHKL=no:; IGEN=no:; IRCD=no:#          Flag hkl and rcode               AR02  53
#                                                                       AR02  54
# LOOP OVER FILE INPUT AND OUTPUT LINES                                 AR02  55
# -------------------------------------                                 AR02  56
#                                                                       AR02  57
REPEAT#                                Loop over lines                  AR02  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR02  59
IF(LINID==1\LINID==7) BREAK#           Break on hkl or end line         AR02  60
NFIL=NFIL+1#                           Increment count                  AR02  61
MARK(NFIL)=MK#                         Pointer into output array        AR02  62
#                                                                       AR02  63
IF(LINID==4)#                          ******* hklgen line *********    AR02  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR02  65
IGEN=yes:#                             Set hkl generate flag            AR02  66
FILE(NFIL)=-1000#                      Generate hkl data                AR02  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR02  68
#                                                                       AR02  69
ELSE IF(LINID==5) FILE(NFIL)=1#        ******* bdfin line *********     AR02  70
ELSE IF(LINID==6) FILE(NFIL)=0#        ******** hklin line ********     AR02  71
ELSE IF(LINID==2) NFIL=NFIL-1#         ******** c line *************    AR02  72
ELSE IF(LINID==3) FILE(NFIL)=-1#       ******** remove line ********    AR02  73
#                                                                       AR02  74
# EXTRACT ITEMS                                                         AR02  75
# -------------                                                         AR02  76
#                                                                       AR02  77
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over fields                 AR02  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR02  79
ifch:(BUFIN(I))#                       Character field                  AR02  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR02  81
stringlim:(I,M,N)#                     String limits                    AR02  82
compchar:(CHRIN,M,AR023,1,4,4,NAR023,N)# Identify string                AR02  83
IF(N==0) iquit:(AR0205,I)#             Unidentified string              AR02  84
#                                                                       AR02  85
IF(N==MXITEM+3)#                       *********** file ***********     AR02  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR02  87
I=I+1#                                 Point to next input field        AR02  88
IF(BUFIN(I)>-1.) ncodefld:(BUFIN,I,FILEXT(IOUNIT(4)),30333.,1)#         AR02  89
ELSE#                                  Extension is alpha code          AR02  90
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR02  91
stringlim:(I,M,N);    K=0#             String limits                    AR02  92
IF(N==M+1) compchar:(CHRIN,M,AR022,1,1,1,2,K)# Check if a or b          AR02  93
IF(K>0) FILEXT(IOUNIT(4))=FILEXT(IOUNIT(K))# Ext of archive files       AR02  94
ELSE    FILEXT(IOUNIT(4))=CHRIN(M^N-1)# Store file extension            AR02  95
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR02  96
FILE(NFIL)=4#                          Store file d number              AR02  97
IOMARK(4)=ISTOP#                       Start of file buffer             AR02  98
incrqx:(ISTOP,ISTOP+bdfbuf:,AR0203)#   Request buffer                   AR02  99
NEXT#                                                                   AR02 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR02 101
#                                                                       AR02 102
ELSE IF(N==MXITEM+2) NEXT#             ************ hkl ************1   AR02 103
#                                                                       AR02 104
ELSE IF(N==MXITEM+1)#                  ************ all ************    AR02 105
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR02 106
readwpkt:(FILE(NFIL),lrrefl:,PSIZE,IP,0)# Read directory                AR02 107
FOR(J=IP+1;J<=IP+PSIZE;J=J+1)#         Loop over directory              AR02 108
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR02 109
idnm:(MK)=QX(J)#                       Idnum                            AR02 110
ifeq:(idnm:(MK),1.) IHKL=yes:#         Flag hkl found                   AR02 111
ifeq:(idnm:(MK),2.) NEXT#              Skip stol                        AR02 112
ifeq:(idnm:(MK),3.) NEXT#              Skip emul                        AR02 113
ifeq:(AMOD(idnm:(MK),1000.),308.) IRCD=yes:# Flag rcode requested       AR02 114
ifeq:(AMOD(idnm:(MK),1000.),204.)#     Maybe skip 1/lp                  AR02 115
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR02 116
IF(LPINS==yes:) NEXT#                  But only if special              AR02 117
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR02 118
IF((idnm:(MK)>500.)&(idnm:(MK)<511.))# Form factors                     AR02 119
NEXT#                                  Skip them                        AR02 120
pnto:(MK)=1.#                          Flag for output                  AR02 121
pmax:(MK)=-99999.#                     Initial max parameter            AR02 122
pmin:(MK)= 99999.#                     Initial min parameter            AR02 123
MK=MK+6#                               Add to pointer                   AR02 124
IF(MK==STOP1) iquit:(AR0206)#          Quit on overflow                 AR02 125
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR02 126
rewindbdf:(FILE(NFIL))#                Rewind file                      AR02 127
BREAK#                                 Go read next line                AR02 128
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR02 129
#                                                                       AR02 130
IF(N==18) IPHI=MK#                     ************ phi *************   AR02 131
idnm:(MK)=DIRN(N)#                     Store id number                  AR02 132
IF(idnm:(MK)>4.) idnm:(MK)=idnm:(MK)+DSNM# Account for dset             AR02 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR02 134
#                                                                       AR02 135
ELSE ifpos:(BUFIN(I)) idnm:(MK)=FLOAT(NINT(BUFIN(I)))# Store idnum      AR02 136
ELSE NEXT#                             Next if void or zero             AR02 137
#                                                                       AR02 138
# TEST FOR HKL, STOL, EMUL AND 1/LP                                     AR02 139
# ---------------------------------                                     AR02 140
#                                                                       AR02 141
ifeq:(idnm:(MK),1.) IHKL=yes:#         Flag hkl                         AR02 142
ifeq:(idnm:(MK),2.) NEXT#              Stol calculated                  AR02 143
ifeq:(idnm:(MK),3.) NEXT#              Emul calculated                  AR02 144
ifeq:(AMOD(idnm:(MK),1000.),308.) IRCD=yes:# Flag rcode requested       AR02 145
ifeq:(AMOD(idnm:(MK),1000.),204.)#     Maybe skip 1/lp                  AR02 146
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR02 147
IF(LPINS==yes:) NEXT#                  But only if special              AR02 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR02 149
IF(FILE(NFIL)==0)#                     For hklin lines                  AR02 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR02 151
pnti:(MK)=FLOAT(I)#                    Store input field no.            AR02 152
IF(LINID==2)#                          Hklin continuation               AR02 153
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR02 154
LINID=6#                               Flag taken care of               AR02 155
pnti:(MK)=pnti:(MK)+101.#              Add arbitrary value              AR02 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR02 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR02 158
pnto:(MK)=1.#                          Flag for output                  AR02 159
IF(FILE(NFIL)==-1) pnto:(MK)=0.#       Turn off remove                  AR02 160
pmax:(MK)=-99999.#                     Initial max                      AR02 161
pmin:(MK)= 99999.#                     Initial min                      AR02 162
MK=MK+6#                               Add to pointer                   AR02 163
IF(MK==STOP1) iquit:(AR0206)#          Quit on overflow                 AR02 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR02 165
readline:(AR021,NAR021)#               Read next line                   AR02 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR02 167
#                                                                       AR02 168
# TEST FILE SETUP                                                       AR02 169
# ---------------                                                       AR02 170
#                                                                       AR02 171
IF(NFIL==0) iquit:(AR0207)#            Not enough files                 AR02 172
IF(IHKL==no:) iquit:(AR0209)#          Quit if no hkl input             AR02 173
#                                                                       AR02 174
# PUT STOL EMUL AND PERHAPS 1/LP IN ITEM LIST                           AR02 175
# -------------------------------------------                           AR02 176
#                                                                       AR02 177
MARK(NFIL+1)=MK#                       Start of calculated items        AR02 178
idnm:(MK)=2.#                          Stol idnm                        AR02 179
pnto:(MK)=1.#                          Flag for output                  AR02 180
pmax:(MK)=-99999.#                     Initial max                      AR02 181
pmin:(MK)= 99999.#                     Initial min                      AR02 182
MK=MK+6#                               Add to pointer                   AR02 183
idnm:(MK)=3.#                          Emul idnm                        AR02 184
pnto:(MK)=1.#                          Flag for output                  AR02 185
pmax:(MK)=-99999.#                     Initial max                      AR02 186
pmin:(MK)= 99999.#                     Initial min                      AR02 187
MK=MK+6#                               Add to pointer                   AR02 188
IF(IRCD==no:)#                         Insert rcode if not requested    AR02 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR02 190
idnm:(MK)=NINT(DSNM)+308.#             Rcode idnm                       AR02 191
pnto:(MK)=1.#                          Flag for output                  AR02 192
pmax:(MK)=-99999.#                     Initial max                      AR02 193
pmin:(MK)= 99999.#                     Initial min                      AR02 194
MK=MK+6#                               Add to pointer                   AR02 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR02 196
IF(LPINS==yes:)#                       If 1/lp is to go out             AR02 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR02 198
idnm:(MK)=NINT(DSNM)+204.#             Make the 1/lp id number          AR02 199
pnto:(MK)=1.0#                         Signal 'yes'                     AR02 200
pmax:(MK)=-99999.#                                                      AR02 201
pmin:(MK)= 99999.#                                                      AR02 202
MK=MK+6#                                                                AR02 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR02 204
IF(MK==STOP1) iquit:(AR0206)#          Quit on overflow                 AR02 205
#                                                                       AR02 206
# ADD OUTPUT DATA TO LIST                                               AR02 207
# -----------------------                                               AR02 208
#                                                                       AR02 209
IF(IOUT!=0)#                           Test for sf conversion           AR02 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR02 211
idnm:(MK)=FLOAT(OUTDAT)#               Store type                       AR02 212
pnto:(MK)=1.#                          Set output flag                  AR02 213
pmax:(MK)=-99999.#                     Initial max                      AR02 214
pmin:(MK)= 99999.#                     Initial min                      AR02 215
idnm:(MK+6)=FLOAT(OUTDAT+1)#           Sigma of output                  AR02 216
pnto:(MK+6)=1.#                        Set output flag                  AR02 217
pmax:(MK+6)=-99999.#                   Initial max                      AR02 218
pmin:(MK+6)= 99999.#                   Initial min                      AR02 219
MK=MK+12#                              Add to pointer                   AR02 220
IF(IFRIED==2)#                         Are friedel mates to be done     AR02 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AR02 222
idnm:(MK)=FLOAT(OUTDAT+10)#            Store type                       AR02 223
pnto:(MK)=1.#                          Set output flag                  AR02 224
pmax:(MK)=-99999.#                     Initial max                      AR02 225
pmin:(MK)= 99999.#                     Initial min                      AR02 226
idnm:(MK+6)=FLOAT(OUTDAT+11)#          Sigma of output                  AR02 227
pnto:(MK+6)=1.#                        Set output flag                  AR02 228
pmax:(MK+6)=-99999.#                   Initial max                      AR02 229
pmin:(MK+6)= 99999.#                   Initial min                      AR02 230
MK=MK+12#                              Add to pointer                   AR02 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AR02 232
IF(MK>=STOP1) iquit:(AR0206)#          Quit on overflow                 AR02 233
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR02 234
#                                                                       AR02 235
#                                                                       AR02 236
# TEST FOR DUPLICATE REQUESTS                                           AR02 237
# ---------------------------                                           AR02 238
#                                                                       AR02 239
FOR(I=MARK1;I<MK-6;I=I+6)#             Loop over input items            AR02 240
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AR02 241
ifeq:(pnto:(I),0.) NEXT#               Skip inactive items              AR02 242
FOR(J=I+6;J<MK;J=J+6)#                 Loop over input items            AR02 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AR02 244
ifeq:(pnto:(J),0.) NEXT#               Skip inactive items              AR02 245
ifeq:(idnm:(I),idnm:(J))#              Duplicate request                AR02 246
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AR02 247
pnto:(J)=0.#                           Turn off duplicate request       AR02 248
err:(J)=3.#                            Status flag                      AR02 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AR02 250
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AR02 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AR02 252
#                                                                       AR02 253
#                                                                       AR02 254
RETURN#                                                                 AR02 255
END#                                                                    AR02 256
systemheader:(AR03)#                   Symmetry & scattering data       AR03   1
###############################################################         AR03   2
#                                                             #         AR03   3
#                           AR03                              #         AR03   4
#                                                             #         AR03   5
###############################################################         AR03   6
SUBROUTINE AR03#                                                        AR03   7
include:(AACOMN)#                                                       AR03   8
include:(ARCOMN)#                                                       AR03   9
#                                                                       AR03  10
INTEGER DATSET#                        Current data set                 AR03  11
INTEGER I,J,K,L#                       Loop index                       AR03  12
INTEGER II#                            Pointer                          AR03  13
INTEGER IP#                            Input bufpt                      AR03  14
INTEGER KREL(101)#                     Relative pointer list            AR03  15
INTEGER IW#                            Count of wanted items            AR03  16
INTEGER IWANT(101)#                    Want list                        AR03  17
INTEGER KEY(4)#                        Keys for indexpkt:               AR03  18
INTEGER JJ#                            Pointer                          AR03  19
INTEGER KK#                            Pointer                          AR03  20
INTEGER LL#                            Pointer                          AR03  21
INTEGER LTYP#                          Lattice code                     AR03  22
INTEGER NMAT#                          Number of matrices same zeros    AR03  23
INTEGER NROT#                          Number of rotation matrices      AR03  24
INTEGER NSYM#                          Number of symmetry matrices      AR03  25
REAL RC(9)#                            Reciprocal lattice constants     AR03  26
REAL COMP#                             Intermediate for lp              AR03  27
chardata:(AR031," Input from XXXXXX.XXX   item idnum ")#                AR03  28
chardata:(AR032," From HKLIN lines --     item idnum ")#                AR03  29
chardata:(AR033,"                         ****            nothing $#    AR03  30
requested")#                                                            AR03  31
chardata:(AR034," STOL will be calculated")#                            AR03  32
chardata:(AR035," EMUL will be calculated")#                            AR03  33
chardata:(AR036," Duplicate request")#                                  AR03  34
chardata:(AR037," No request for output")#                              AR03  35
chardata:(AR038," ***** missing lrrefl *****")#                         AR03  36
chardata:(AR039," Item not in lrrefl")#                                 AR03  37
chardata:(AR03B," Remove from output --   item idnum")#                 AR03  38
chardata:(AR03C," Wavelength in Angstroms                 ")#           AR03  39
chardata:(AR03D," Two-theta angle of monochromator          ")#         AR03  40
chardata:(AR03E," Monochromator crystal perfection          ")#         AR03  41
chardata:(AR03F,"[ Reflection data to be generated  -&+h -&+k -&+l]")#  AR03  42
chardata:(AR03G," Generated hkl data --   item idnum")#                 AR03  43
chardata:(AR03H," Polarization of source beam               ")#         AR03  44
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              AR03  45
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              AR03  46
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              AR03  47
realdata:(TR21,[.3333333,.5])#                                          AR03  48
realdata:(TR22,[.6666667,0.])#                                          AR03  49
realdata:(TR23,[.6666667,.5])#                                          AR03  50
datastuff:#                                                             AR03  51
#                                                                       AR03  52
# GET RECIPROCAL METRIC TENSOR FROM PKT 8 OF LRCELL:                    AR03  53
# --------------------------------------------------                    AR03  54
#                                                                       AR03  55
DO I=1,9#                              Loop over lrcell: packets        AR03  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR03  57
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read packet                      AR03  58
IF(IP<=0) BREAK#                       Break at end of lr               AR03  59
IF(I==3)#                              Correct packet                   AR03  60
DO J=1,9; RC(J)=QX(IP+J)#              Get recip lattice constants      AR03  61
IF(I==8)#                              Correct packet                   AR03  62
DO J=1,9; RM(J)=QX(IP+J)#              Get recip metric tensor          AR03  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR03  64
#                                                                       AR03  65
# GET CENTRICITY AND LATTICE CODES FROM PKT 1 OF LRSYMM:                AR03  66
# ------------------------------------------------------                AR03  67
#                                                                       AR03  68
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      AR03  69
IF(IP<=0) iquit:(AR0312)#              Quit if pkt not there            AR03  70
ICNT=1-NINT(QX(IP+2))#                 Centricity a=0   c=1             AR03  71
LTYP=NINT(QX(IP+1))-7*ICNT#            Lattice code                     AR03  72
NSYM=NINT(QX(IP+3))#                   Total symmetry matrices          AR03  73
NROT=NINT(QX(IP+4))*12#                Limit of rotation matrices       AR03  74
NMAT=NINT(QX(IP+5))*12#                Matrices with same zeros         AR03  75
#                                                                       AR03  76
# GET SYMMETRY EQUIVALENT POSITIONS FROM LRSYMM:                        AR03  77
# ----------------------------------------------                        AR03  78
#                                                                       AR03  79
MARK2=ISTOP#                           Start of s.e.p. matrices         AR03  80
incrqx:(ISTOP,MARK2+NSYM*12,AR0313)#   Request memory all symops        AR03  81
JJ=MARK2+NROT;   KK=MARK2+NMAT#        Limit of rotation matrices       AR03  82
FOR(II=MARK2;II<JJ;II=II+12)#          Loop over symmetry matrices      AR03  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR03  84
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      AR03  85
IF(IP<=0) BREAK#                       Break at end                     AR03  86
movereal:(QX,IP+1,QX,II+1,12,1)#       Transfer packet                  AR03  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR03  88
IF(ICNT==1)#                           If centrosymmetric               AR03  89
DO I=1,NROT; QX(JJ+I)=-QX(MARK2+I)#    Store inverse matrix             AR03  90
#                                                                       AR03  91
#     EXPAND SYMOP TABLE FOR CENTRES                                    AR03  92
#     ------------------------------                                    AR03  93
#                                                                       AR03  94
II=JJ+ICNT*NROT; ISTOP=II#             Store primitive marker           AR03  95
IF(LTYP>1)#                            Test if sg centered              AR03  96
FOR(J=MARK2;J<ISTOP;J=J+12)#           Loop over symm matrices          AR03  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR03  98
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            AR03  99
QX(II+10)=QX(J+10)+TR11(LTYP-1)#       Transfer t1                      AR03 100
QX(II+11)=QX(J+11)+TR12(LTYP-1)#       Transfer t2                      AR03 101
QX(II+12)=QX(J+12)+TR13(LTYP-1)#       Transfer t3                      AR03 102
II=II+12#                              Incr storage pointer             AR03 103
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               AR03 104
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            AR03 105
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      AR03 106
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      AR03 107
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      AR03 108
II=II+12#                              Incr storage pointer             AR03 109
IF(LTYP!=4) NEXT#                      Skip if not f-centre             AR03 110
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            AR03 111
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      AR03 112
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      AR03 113
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      AR03 114
II=II+12#                              Incr storage pointer             AR03 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR03 116
ISTOP=II#                              End of mark2 array               AR03 117
#                                                                       AR03 118
#  EXTRACT GENERATED HKL SIGNS                                          AR03 119
#  ---------------------------                                          AR03 120
#                                                                       AR03 121
IF(IGEN==yes: &GENALL==no:)#           Reduced hkl to be generated      AR03 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR03 123
DO I=1,3; HNEG(I)=1.#                  Allow all negatives              AR03 124
FOR(II=MARK2+12;II<KK;II=II+12)#       Loop over unique matrices        AR03 125
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR03 126
J=-3#                                  Start diag element pointer       AR03 127
DO I=1,3#                              Loop over hkl signs              AR03 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR03 129
J=J+4#                                 Incr diag element pointer        AR03 130
ifeq:(QX(II+J),1.) NEXT#               Skip positive elements           AR03 131
ifeq:(HNEG(I),0.) NEXT#                Skip if already shut off         AR03 132
HNEG(I)=0.;    BREAK#                  Shut off negative and exit       AR03 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR03 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR03 135
IF(ICNT==1\IFRIED==1)#                 If friedel not required          AR03 136
DO I=1,3#                              Loop over hkl signs              AR03 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR03 138
ifeq:(HNEG(I),0.) NEXT#                Skip if already shut off         AR03 139
HNEG(I)=0.;    BREAK#                  Shut off negative and exit       AR03 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR03 141
DO I=1,3#                              Loop over hkl signs              AR03 142
ifeq:(HNEG(I),0.)movechar:(BLANK,1,AR03F,30+I*5,2,0)# Blank out '-&'    AR03 143
writeline:(0,AR03F,NAR03F,3,3)#        Print generator message          AR03 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR03 145
ELSEIF(IGEN==yes:&GENALL==yes:)#       Generate whole sphere            AR03 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR03 147
DO I=1,3; HNEG(I)=1.#                  Allow all negatives              AR03 148
writeline:(0,AR03F,NAR03F,3,3)#        Print generator message          AR03 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR03 150
#                                                                       AR03 151
# STORE STOL VALUES AND RELATIVE POINTERS IN TABLE                      AR03 152
# FOR EACH STOL VALUE, WE HAVE THE FOLLOWING:                           AR03 153
# STOL,RELATIVE POINTER,Y1,Y2,....,Y10                                  AR03 154
# WHERE Y1,...,Y10 ARE THE SCATTERING FACTORS FOR THAT STOL VALUE       AR03 155
#  FOR UP TO 10 ATOMS                                                   AR03 156
# ---------------------------------------------------------------       AR03 157
#                                                                       AR03 158
MARK3=ISTOP#                           Start of ff table                AR03 159
II=MARK3#                              Running pointer                  AR03 160
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read directory                   AR03 161
IF(IP<=0) iquit:(AR0314)#              Quit if not there                AR03 162
FOR(I=IP+1;I<=IP+PSIZE;I=I+1)#         Loop over directory              AR03 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR03 164
ifeq:(QX(I),10.) INEU=yes:#            Check for neutron ff             AR03 165
IF(FFAC==yes:)#                        Form factors requested           AR03 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR03 167
IF((QX(I)<99.9)\(QX(I)>299.1)) NEXT#   Skip non-ff                      AR03 168
incrqx:(ISTOP,II+12,AR0315)#           Mem request                      AR03 169
QX(II+1)=(QX(I)-100.)/100.#            Stol value                       AR03 170
QX(II+2)=FLOAT(I-IP)#                  Relative pointer                 AR03 171
II=ISTOP#                              Running pointer                  AR03 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR03 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR03 174
ISTOP=II#                              End of mark3 array               AR03 175
#                                                                       AR03 176
# GET FORM FACTOR TABLES FROM LRSCAT:                                   AR03 177
# -----------------------------------                                   AR03 178
#                                                                       AR03 179
FOR(II=1;II>0;II=II+1)#                Loop over atom types             AR03 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR03 181
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read packet                      AR03 182
IF(IP<=0) BREAK#                       Break at end of lr               AR03 183
IF(FFAC==yes:)#                        Form factors requested           AR03 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR03 185
idnm:(MK)=FLOAT(500+II)#               Ff idnum                         AR03 186
pnto:(MK)=1.#                          Flag for output                  AR03 187
pmax:(MK)=-99999.#                     Initial max                      AR03 188
pmin:(MK)= 99999.#                     Initial min                      AR03 189
MK=MK+6#                               Add to pointer                   AR03 190
IF(MK==STOP1) iquit:(AR0317)#          Overflow                         AR03 191
FOR(I=MARK3;I<ISTOP;I=I+12)#           Loop over ff pointers            AR03 192
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR03 193
L=IP+NINT(QX(I+2))#                    Point to ff                      AR03 194
IF(QX(L)<small:) QX(L)=2.*QX(L-1)-QX(L-2)# Interpolate                  AR03 195
LL=II+I+2#                             Pointer into mark3               AR03 196
QX(LL)=QX(L)#                          Store ff                         AR03 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR03 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR03 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR03 200
#                                                                       AR03 201
# GET LAMBDA AND SCALE GROUP FROM LREXPL:                               AR03 202
# --------------------------------------                                AR03 203
#                                                                       AR03 204
IWANT(1)=2#                            Request lambda                   AR03 205
IWANT(2)=100#                          Request scale group              AR03 206
KEY(1)=0#                              No mandatory requests            AR03 207
KEY(2)=2#                              2 or 3 optional request          AR03 208
KEY(3)=0#                              No additions or deletions        AR03 209
KEY(4)=0#                              Non-archive mode                 AR03 210
indexpkt:(1,lrexpl:,PSIZE,IP,0,KEY,IWANT,KREL)#                         AR03 211
DATSET=NINT(DSNM/1000.)#               Data set to process              AR03 212
DO I=1,DATSET#                         Step to current data set         AR03 213
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Read packet                      AR03 214
#                                                                       AR03 215
II=IP+KREL(1)#                         Point to lambda                  AR03 216
IF(II<=IP) LAMBDA=.71069#              Default moly k alpha             AR03 217
ELSE       LAMBDA=QX(II)#              Extract lambda                   AR03 218
ifvo:(LAMBDA) iquit:(AR0301)#          Lambda has not been set          AR03 219
SMAX=AMIN1(SMAX,.99999/LAMBDA)#        Set sin(t)/wl maximum            AR03 220
ncodefld:(LAMBDA,1,AR03C,380752.,1)#   Format wavelength                AR03 221
writeline:(0,AR03C,NAR03C,3,3)#        Print wavelength                 AR03 222
#                                                                       AR03 223
II=IP+KREL(2)#                         Point to scl grp num             AR03 224
IF(II<=IP) NSCGRP=1#                   Default to one scale grp         AR03 225
ELSE       NSCGRP=NINT(QX(II))#        Fetch given no.                  AR03 226
#                                                                       AR03 227
IF((IRLP==3)\(IRLP==4))#               If monochrometer is used         AR03 228
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR03 229
IF(MONO2T<-1.)#                        Default graphite monochr.        AR03 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR03 231
MONO2T=LAMBDA/6.708#                   Lambda/(2*lattice spacing)       AR03 232
MONO2T=2.*ASIN(MONO2T)/.01745329#      2 * monochrometer angle          AR03 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR03 234
ncodefld:(MONO2T,1,AR03D,410832.,1)#   Encode monochrom 2 theta         AR03 235
writeline:(0,AR03D,NAR03D,3,3)#        And report it.                   AR03 236
MONO2T=COS(0.01745329*MONO2T)#         Convert to cosine for lp         AR03 237
ncodefld:(MONOPF,1,AR03E,410832.,1)#   Encode monochr. perfection       AR03 238
writeline:(0,AR03E,NAR03E,3,3)#        And report it too.               AR03 239
ncodefld:(POLFR,1,AR03H,410832.,1)#    Report polarization of source    AR03 240
writeline:(0,AR03H,NAR03H,3,3)#        Beam incident on monochromator   AR03 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR03 242
ELSE MONO2T=1.#                        Set 2theta mono to 0.            AR03 243
MARK(NFIL+2)=MK#                       End of output items              AR03 244
#                                                                       AR03 245
# CALCULATE PPFAC - THE PERPENDICULAR POLARIZATION RATIO                AR03 246
# OF RADIATION INCIDENT ON THE CRYSTALS                                 AR03 247
# ------------------------------------------------------                AR03 248
#                                                                       AR03 249
COMP=(1.-POLFR)*((1.-MONOPF)*MONO2T**2 +MONOPF*MONO2T)# Local variabl   AR03 250
IF     (IRLP==1) PPFAC=POLFR/(COMP+POLFR)# Powder                       AR03 251
ELSE IF(IRLP==2) PPFAC=POLFR/(COMP+POLFR)# Eulerian cradle/2theta       AR03 252
ELSE IF(IRLP==3) PPFAC=COMP/(COMP+POLFR)# Diffr perp monochr.           AR03 253
ELSE IF(IRLP==4) PPFAC=POLFR/(COMP+POLFR)# Diffr equator. monochr.      AR03 254
ELSE             PPFAC=0.5#            Default - unpolarized            AR03 255
IF(INEU==yes:)   PPFAC=POLFR#          No changes in pol for neutrons   AR03 256
#                                                                       AR03 257
#   SET UP LIMITS FOR GENERATED HKL                                     AR03 258
#   -------------------------------                                     AR03 259
#                                                                       AR03 260
IF(IGEN==yes:)#                        If hkl to be generated           AR03 261
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR03 262
DO I=7,9; RC(I)=ABS(SIN(RC(I)*6.2831853))# Get sine of angles           AR03 263
ifne:(HX,999.) HPOS(1)=HX#             Set max h                        AR03 264
ELSE           HPOS(1)=2.*SMAX/(RC(1)*RC(8)*RC(9))# Calc h max          AR03 265
ifne:(KX,999.) HPOS(2)=KX#             Set max k                        AR03 266
ELSE           HPOS(2)=2.*SMAX/(RC(2)*RC(7)*RC(9))# Calc k max          AR03 267
ifne:(LX,999.) HPOS(3)=LX#             Set max l                        AR03 268
ELSE           HPOS(3)=2.*SMAX/(RC(3)*RC(8)*RC(7))# Calc l max          AR03 269
DO I=1,3; HPOS(I)=FLOAT(NINT(HPOS(I)))# Intergerize maxima              AR03 270
DO I=1,3; ifne:(HNEG(I),0.) HNEG(I)=-HPOS(I)# Set hkl minimum           AR03 271
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR03 272
#                                                                       AR03 273
# GET RELATIVE POINTERS FOR INPUT ITEMS                                 AR03 274
# -------------------------------------                                 AR03 275
#                                                                       AR03 276
KEY(1)=0#                              No mandatory items               AR03 277
KEY(3)=0#                              No insertions or deletions       AR03 278
KEY(4)=0#                              Non-update mode                  AR03 279
DO I=1,NFIL#                           Loop over files                  AR03 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AR03 281
IF(FILE(I)<=0) NEXT#                   Skip hklin,remove                AR03 282
IW=0#                                  Count of items                   AR03 283
FOR(J=MARK(I);J<MARK(I+1);J=J+6)#      Loop over input items            AR03 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AR03 285
IW=IW+1#                               Increment count                  AR03 286
IWANT(IW)=NINT(idnm:(J))#              Get id number request list       AR03 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AR03 288
IF(IW==0) NEXT#                        Skip if no items                 AR03 289
KEY(2)=IW#                             Number of optional items         AR03 290
indexpkt:(FILE(I),lrrefl:,PSIZE,IP,0,KEY,IWANT,KREL)#                   AR03 291
IF(IP<=0)#                             No lrrefl:                       AR03 292
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AR03 293
FOR(J=MARK(I);J<MARK(I+1);J=J+6)#      Loop over input items            AR03 294
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AR03 295
pnto:(J)=0.0#                          Mark item not there              AR03 296
err:(J)=5.#                            Error,reason 5                   AR03 297
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AR03 298
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AR03 299
ELSE#                                  Lrrefl: there                    AR03 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AR03 301
IW=0#                                  Zero count                       AR03 302
FOR(J=MARK(I);J<MARK(I+1);J=J+6)#      Loop over input                  AR03 303
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AR03 304
IW=IW+1#                               Increment count                  AR03 305
ifeq:(pnto:(J),0.)               NEXT# Item already not there           AR03 306
pnti:(J)=FLOAT(KREL(IW))#              Store rel pt to item             AR03 307
ifeq:(AMOD(idnm:(J),1000.),308.) NEXT# Skip rcode requested             AR03 308
IF(KREL(IW)>0)                   NEXT# Idnum is present                 AR03 309
pnto:(J)=0.#                           Mark as not present              AR03 310
err:(J)=6.#                            Error, reason 6                  AR03 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AR03 312
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AR03 313
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AR03 314
#                                                                       AR03 315
# STATUS REPORT FOR USER                                                AR03 316
# ----------------------                                                AR03 317
#                                                                       AR03 318
DO I=1,NFIL#                           Loop over files                  AR03 319
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AR03 320
IF(FILE(I)==0)#                        Input from control lines         AR03 321
writeline:(1,AR032,NAR032,3,3)#        Heading                          AR03 322
ELSE IF(FILE(I)==-1000)#               Generated hkl                    AR03 323
writeline:(1,AR03G,NAR03G,3,3)#        Heading                          AR03 324
ELSE IF(FILE(I)>0)#                    Input from bdf                   AR03 325
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AR03 326
K=FILE(I)#                             Get proper unit no.              AR03 327
movechar:(FILENM(IOUNIT(K)),1,AR031,13,10,0)# Insert filename           AR03 328
writeline:(1,AR031,NAR031,3,3)#        Write heading                    AR03 329
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AR03 330
ELSE writeline:(1,AR03B,NAR03B,3,3)#   Removals heading                 AR03 331
#                                                                       AR03 332
IF(MARK(I)==MARK(I+1))#                No items requested               AR03 333
writeline:(1,AR033,NAR033,3,3)#        Message                          AR03 334
#                                                                       AR03 335
FOR(J=MARK(I);J<MARK(I+1);J=J+6)#      Loop over input requests         AR03 336
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AR03 337
ncodefld:(idnm:(J),1,CHROT,350413.,1)# Encode idnum                     AR03 338
ifeq:(err:(J),1.)#                     Error message                    AR03 339
movechar:(AR034,1,CHROT,44,NAR034,0)#  Move message                     AR03 340
ELSE ifeq:(err:(J),2.)#                Error message                    AR03 341
movechar:(AR035,1,CHROT,44,NAR035,0)#  Move message                     AR03 342
ELSE ifeq:(err:(J),3.)#                Error message                    AR03 343
movechar:(AR036,1,CHROT,44,NAR036,0)#  Move message                     AR03 344
ELSE ifeq:(err:(J),4.)#                Error message                    AR03 345
movechar:(AR037,1,CHROT,44,NAR037,0)#  Move message                     AR03 346
ELSE ifeq:(err:(J),5.)#                Error message                    AR03 347
movechar:(AR038,1,CHROT,44,NAR038,0)#  Move message                     AR03 348
ELSE ifeq:(err:(J),6.)#                Error message                    AR03 349
movechar:(AR039,1,CHROT,44,NAR039,0)#  Move message                     AR03 350
#                                                                       AR03 351
DO K=1,MXITEM#                         Loop over directory array        AR03 352
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AR03 353
ifeq:(AMOD(idnm:(J),1000.),DIRN(K))#   Match name to dirn               AR03 354
movechar:(AR023,4*(K-1)+1,CHROT,26,4,0)# Move name                      AR03 355
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AR03 356
writeline:(0,0,0,1,3)#                 Write line                       AR03 357
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AR03 358
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AR03 359
#                                                                       AR03 360
RETURN#                                                                 AR03 361
END#                                                                    AR03 362
systemheader:(AR04)#                   Enter reflection files           AR04   1
##############################################################          AR04   2
#                                                            #          AR04   3
#                            AR04                            #          AR04   4
#                                                            #          AR04   5
##############################################################          AR04   6
SUBROUTINE AR04#                                                        AR04   7
include:(AACOMN)#                                                       AR04   8
include:(ARCOMN)#                                                       AR04   9
#                                                                       AR04  10
REAL A,B,C#                            Rotated h,k,l                    AR04  11
REAL D,DVAL#                           D-spacings                       AR04  12
REAL HKL(3)#                           Unpacked h,k,l                   AR04  13
REAL PROD#                             Term in interpolation            AR04  14
REAL PQ(100)#                          Proto-qx buffer for output       AR04  15
REAL RLPMIN#                           Minimum 1/lp                     AR04  16
REAL RLPMAX#                           Maximum 1/lp                     AR04  17
REAL SUM#                              Interp form factor               AR04  18
INTEGER ABSNT#                         Reflection absent flag           AR04  19
INTEGER EPS#                           Augment to epsilon               AR04  20
INTEGER I,J,K,L,M#                     Loop indices                     AR04  21
INTEGER II,JJ,KK,LL#                   Pointers                         AR04  22
INTEGER IDN#                           Current idnum                    AR04  23
INTEGER IFIL#                          File number                      AR04  24
INTEGER IMAR#                          End marker                       AR04  25
INTEGER INCR#                          Skip fields k,l                  AR04  26
INTEGER IJK,JKJ,JKL#                   Working pointers                 AR04  27
INTEGER IP#                            Bufpt for file 2                 AR04  28
INTEGER IPAK#                          Input packet size                AR04  29
INTEGER IPP#                           True bufpt for  file 2           AR04  30
INTEGER IPT#                                                            AR04  31
INTEGER IWRITE#                                                         AR04  32
INTEGER IZERO#                         Null                             AR04  33
INTEGER I1#                            Point to interpolation point     AR04  34
INTEGER JFIL#                          Previous file number             AR04  35
INTEGER MUL#                           Multiplicity                     AR04  36
INTEGER NROT#                          Number of rotation matrices      AR04  37
INTEGER PSIZ#                          Input packet size                AR04  38
INTEGER REASON#                        Reason for ref rejection         AR04  39
INTEGER PRC#                           Phase restriction code           AR04  40
#                                                                       AR04  41
chardata:(AR041, HKL C REMOVE HKLGEN BDFIN HKLIN END)#                  AR04  42
chardata:(AR042," Reflection XXXX XXXX XXXX rejected        .")#        AR04  43
chardata:(AR043,MAXHKL MAXSTOLSYSABS SYSABS RCODE  SCLGRP NOTABS )#     AR04  44
realdata:(FMT,[160413.,210413.,260413.])#                               AR04  45
realdata:(STOL,0.);   realdata:(TINY,0.000001)#                         AR04  46
realdata:(X,0.);  realdata:(Y,0.);  realdata:(Z,0.)#                    AR04  47
intdata:(JPR,[1,0,2,3,4,0,5,0,6,7,8,0])#                                AR04  48
datastuff:#                                                             AR04  49
#                                                                       AR04  50
# MARK ITEMS FOR OUTPUT                                                 AR04  51
# ---------------------                                                 AR04  52
#                                                                       AR04  53
DO I=1,3; HKL(I)=0.0#                                                   AR04  54
DO I=1,100; PQ(I)=0.0#                 Zero input parameters            AR04  55
LINID=7#                               Set linid to 'end' value         AR04  56
PSIZE=3#                               Minimum pkt size                 AR04  57
FOR(I=MARK1;I<MK;I=I+6)#               Loop over items                  AR04  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR04  59
ifeq:(pnto:(I),0.) NEXT#               Skip bad items                   AR04  60
IF(idnm:(I)<4.) pnto:(I)=idnm:(I)#     Hkl,stol,emul                    AR04  61
ELSE#                                  Others                           AR04  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR04  63
PSIZE=PSIZE+1#                         Increment psize                  AR04  64
pnto:(I)=FLOAT(PSIZE)#                 Output pointer                   AR04  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR04  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR04  67
PSIZHO=PSIZE#                          Save total packet size for a     AR04  68
#                                                                       AR04  69
# WRITE LRREFL: DIRECTORY                                               AR04  70
# -----------------------                                               AR04  71
#                                                                       AR04  72
writepkt:(3,lrrefl:,PSIZE,IPP)#        **** writepkt ****               AR04  73
FOR(I=MARK1;I<MK;I=I+6)#               Loop over input                  AR04  74
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR04  75
ifeq:(pnto:(I),0.) NEXT#               Skip if not there                AR04  76
IPT=IPP+NINT(pnto:(I))#                Point to op packet               AR04  77
QX(IPT)=idnm:(I)#                      Store idnum                      AR04  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR04  79
#                                                                       AR04  80
# FULL BUFFERS ALL AROUND                                               AR04  81
# -----------------------                                               AR04  82
#                                                                       AR04  83
DO I=1,NFIL#                           Loop over files                  AR04  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR04  85
PAKPT(I)=0#                                                             AR04  86
IF(FILE(I)<=0) NEXT#                   Skip if not bdf                  AR04  87
readwpkt:(FILE(I),lrrefl:,PSIZ,PAKPT(I),0)# **** readwpkt ****          AR04  88
IF(PAKPT(I)<=0) iquit:(AR0401)#        Missing lrrefl:                  AR04  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR04  90
#                                                                       AR04  91
# FORM LRREFL: OUTPUT PACKETS                                           AR04  92
# ---------------------------                                           AR04  93
#                                                                       AR04  94
IZERO=0#                               Used to clear packed words       AR04  95
DO I=1,3 ; HKLMAX(I)=-999.#            Initial max hkl                  AR04  96
DO I=1,3 ; HKLMIN(I)=999.#             Initial min hkl                  AR04  97
IF(IGEN==yes:)#                        If reflections generated         AR04  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR04  99
DO I=1,3; HKL(I)=HNEG(I); HKL(1)=HKL(1)-1.# Set initial hkl counters    AR04 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR04 101
STOLMX=0.0#                            Max stol                         AR04 102
STOLMN=180.0#                          Min stol                         AR04 103
EPSLMX=0.0#                            Max epsilon                      AR04 104
EPSLMN=99999.#                         Min multiplicity                 AR04 105
MULMAX=0.0#                            Max multiplicity                 AR04 106
MULMIN=99999.#                         Min multiplicity                 AR04 107
PRCMAX=0.#                             Max phase restr code             AR04 108
PRCMIN=99999.#                         Min phase restr code             AR04 109
RLPMAX=-999.#                          Maximum 1/lp                     AR04 110
RLPMIN=999.#                           Minimum 1/lp                     AR04 111
NROT=(MARK3-MARK2)/12#                 Get number of rotations          AR04 112
IP=0#                                  Set base pointer into pq()       AR04 113
#                                                                       AR04 114
#   LOOP OVER ALL REFLECTIONS                                           AR04 115
#   -------------------------                                           AR04 116
#                                                                       AR04 117
REPEAT#                                Loop over reflections            AR04 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR04 119
IWRITE=no:#                            Signal for writepkt:             AR04 120
INCR=0;      IFIL=0#                   Offset for hkl fields            AR04 121
#                                                                       AR04 122
FOR(I=1;I<=NFIL+1;I=I+1)#              Loop over files                  AR04 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR04 124
JFIL=IFIL#                             Save last input file type        AR04 125
IPAK=PAKPT(I);   IFIL=FILE(I)#         Get packet pointer & file        AR04 126
IMAR=MARK(I+1)#                        Get end marker                   AR04 127
#                                                                       AR04 128
FOR(J=MARK(I);J<IMAR;J=J+6)#           Loop over items                  AR04 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR04 130
JKJ=NINT(pnti:(J))#                    Input pointer                    AR04 131
IF(IFIL==0 & JKJ>100)#                 Continue hkl line                AR04 132
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR04 133
JKJ=JKJ-101#                           Reset input pointer              AR04 134
readline:(AR041,NAR041)#               Read next line                   AR04 135
IF(LINID!=2) iquit:(AR0402)#           Must be continuation line        AR04 136
INCR=0#                                Reset h,k,l offset               AR04 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR04 138
#                                                                       AR04 139
JKL=NINT(pnto:(J))#                    Output pointer                   AR04 140
IF(JKL==0)  NEXT#                      Skip if item not output          AR04 141
IDN=MOD(NINT(idnm:(J)),1000)#          Get current idnum                AR04 142
II=IP+JKL#                             Output buffer pointer            AR04 143
#                                                                       AR04 144
# PROCESS HKL INDICES                                                   AR04 145
# -------------------                                                   AR04 146
#                                                                       AR04 147
IF(IDN==1&idnm:(J)<1000)#              Test for hkl word                AR04 148
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR04 149
IF(IFIL>0) gethkl:(IPAK+JKJ,HKL)#      Unpack hkl                       AR04 150
ELSE IF(IFIL==0)#                      If hkl lines                     AR04 151
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR04 152
DO K=1,3; HKL(K)=BUFIN(K+JKJ-1)#       Get from line                    AR04 153
INCR=2#                                Offset to rest of items          AR04 154
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR04 155
ELSE IF(IFIL==-1000)#                  Generate hkl indices             AR04 156
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR04 157
INCR=2#                                Offset to rest of items          AR04 158
HKL(1)=HKL(1)+1.#                      Incr h counter                   AR04 159
IF(HKL(1)>HPOS(1))#                    Test if h limit exceeded         AR04 160
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR04 161
HKL(1)=HNEG(1)#                        Reset to h minimum               AR04 162
HKL(2)=HKL(2)+1.#                      Incr k counter                   AR04 163
IF(HKL(2)>HPOS(2))#                    Test if k limit exceeded         AR04 164
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR04 165
HKL(2)=HNEG(2)#                        Reset to k minimum               AR04 166
HKL(3)=HKL(3)+1.#                      Incr l counter                   AR04 167
IF(HKL(3)>HPOS(3)) GOTO 200#           Exit reflection loop             AR04 168
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR04 169
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR04 170
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR04 171
X=HKL(1) ; Y=HKL(2) ; Z=HKL(3)#        Store temporary                  AR04 172
IF(ABS(X)>HX \ ABS(Y)>KX \ ABS(Z)>LX)# Test h,k,l max values            AR04 173
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR04 174
REASON= 1;     GOTO 100#               Set reason flag                  AR04 175
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR04 176
IF(ITRF==yes:)#                        Transform hkl                    AR04 177
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR04 178
HKL(1)=X*TM(1)+Y*TM(2)+Z*TM(3)#        Transformed h'                   AR04 179
HKL(2)=X*TM(4)+Y*TM(5)+Z*TM(6)#        Transformed k'                   AR04 180
HKL(3)=X*TM(7)+Y*TM(8)+Z*TM(9)#        Transformed l'                   AR04 181
X=HKL(1) ; Y=HKL(2) ; Z=HKL(3)#        Store temporary                  AR04 182
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR04 183
IF(ITRF==yes: \ INCR==2)#              If new hkl word                  AR04 184
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AR04 185
intpak:(IZERO,PQ(II),0,mxbtwd:)#       Clear word                       AR04 186
DO JJ=1,3#                             Loop over h,k,l                  AR04 187
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AR04 188
IJK=NINT(HKL(4-JJ))#                   Integerize index                 AR04 189
KK=0#                                  Sign of index                    AR04 190
IF(IJK<0)#                             Negative index                   AR04 191
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AR04 192
IJK=-IJK#                              Make index positive              AR04 193
KK=1#                                  Take note of negative            AR04 194
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AR04 195
intpak:(KK,PQ(II),JJ-1,1)#             Pack the sign                    AR04 196
intpak:(IJK,PQ(II),(JJ-1)*9+3,9)#      Pack the index                   AR04 197
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AR04 198
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AR04 199
ELSE movepakwd:(QX(IPAK+JKJ),PQ(II))#  Transfer input hkl word          AR04 200
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR04 201
#                                                                       AR04 202
# CALCULATE SIN(THETA)/LAMBDA                                           AR04 203
# ---------------------------                                           AR04 204
#                                                                       AR04 205
ELSE IF(IDN==2&idnm:(J)<1000)#         Test if sin theta/lambda         AR04 206
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AR04 207
STOL=.5*SQRT(X*(X*RM(1)+Y*RM(2)+Z*RM(3))$# Apply metric tensor          AR04 208
            +Y*(X*RM(4)+Y*RM(5)+Z*RM(6))$# Apply metric tensor          AR04 209
            +Z*(X*RM(7)+Y*RM(8)+Z*RM(9)))# Apply metric tensor          AR04 210
IF(JFIL>-999&STOL*LAMBDA>1.0) iquit:(AR0403)# Sine theta exceeds 1.0    AR04 211
IF(STOL<0.00001)#                      Test for the 0,0,0 refln         AR04 212
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AR04 213
REASON=3;    GOTO 100#                 This is should not be here       AR04 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AR04 215
DVAL=0.5/STOL#                         D spacing                        AR04 216
IF(STOL>SMAX\DVAL<DMIN)#               Check d limits                   AR04 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AR04 218
REASON=2;    GOTO 100#                 Set reason flag                  AR04 219
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AR04 220
PQ(II)=STOL#                           Store stol                       AR04 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AR04 222
#                                                                       AR04 223
# DO EPSILON AND MULTIPLICITY                                           AR04 224
# ---------------------------                                           AR04 225
#                                                                       AR04 226
ELSE IF(IDN==3&idnm:(J)<1000)#         Test if eps/mul word             AR04 227
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AR04 228
MUL=0;   EPS=0;   PRC=ICNT#            Reset hkl mult/epsilon/prc       AR04 229
ABSNT=no:#                             Assume not absent                AR04 230
FOR(K=MARK2;K<MARK3;K=K+12)#           Loop over symmetry matrices      AR04 231
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AR04 232
A=X*QX(K+1)+Y*QX(K+2)+Z*QX(K+3)#       Generate h'                      AR04 233
B=X*QX(K+4)+Y*QX(K+5)+Z*QX(K+6)#       Generate k'                      AR04 234
C=X*QX(K+7)+Y*QX(K+8)+Z*QX(K+9)#       Generate l'                      AR04 235
D=X*QX(K+10)+Y*QX(K+11)+Z*QX(K+12)#    Generate shift                   AR04 236
M=MOD(NINT(12.*D)+120,12)#             Ensure d in 12ths of 2pi         AR04 237
IF((ABS(A-X)<TINY)$#                   H=h'                             AR04 238
&  (ABS(B-Y)<TINY)$#                   K=k'                             AR04 239
&  (ABS(C-Z)<TINY))#                   L=l'                             AR04 240
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AR04 241
MUL=MUL+1#                             Count equiv hkl                  AR04 242
IF(M==0) EPS=EPS+1#                    Count reinforcement factor       AR04 243
ELSE#                                  Reflection is absent             AR04 244
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AR04 245
EPS=EPS+1#                             Count reinforcement factor       AR04 246
ABSNT=yes:#                            Flag reflection as absent        AR04 247
IF (SABS==yes:) NEXT#                  Skip if sysabs not requ.         AR04 248
REASON=3;  GOTO 100#                   Set reason flag                  AR04 249
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AR04 250
NEXT#                                  Next eq pos                      AR04 251
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AR04 252
IF((ABS(A+X)<TINY)$#                   H=-h'                            AR04 253
&  (ABS(B+Y)<TINY)$#                   K=-k'                            AR04 254
&  (ABS(C+Z)<TINY))#                   L=-l'                            AR04 255
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 AR04 256
MUL=MUL+1#                             Incr multiplicity counter        AR04 257
IF(PRC==0) PRC=JPR(M+1)#               Store phase restriction code     AR04 258
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 AR04 259
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AR04 260
MUL=NROT/MUL#                          Calculate hkl multiplicity       AR04 261
intpak:(IZERO,PQ(II),0,mxbtwd:)#       Clear word                       AR04 262
intpak:(MUL,PQ(II),0,5)#               Pack multiplicity                AR04 263
intpak:(EPS,PQ(II),5,7)#               Pack epsilon                     AR04 264
intpak:(PRC,PQ(II),12,4)#              Pack phase restriction code      AR04 265
IF (OABS==yes:& ABSNT==no:)#           Discard normal reflections       AR04 266
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AR04 267
REASON=7;  GOTO 100#                   Set reason flag                  AR04 268
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AR04 269
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AR04 270
#                                                                       AR04 271
# DO 1/LP IF SO CODED                                                   AR04 272
# -------------------                                                   AR04 273
#                                                                       AR04 274
ELSE IF(IDN==204) PQ(II)=1.0#          Set for ar05                     AR04 275
#                                                                       AR04 276
# DO RCODE                                                              AR04 277
# --------                                                              AR04 278
#                                                                       AR04 279
ELSE IF(IDN==308)#                     Test for rcode                   AR04 280
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 AR04 281
IF(JKJ==0) PQ(II)=1.#                  Store rcode as 1.0               AR04 282
ELSE IF(IFIL==0)#                      Hkl lines input                  AR04 283
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 AR04 284
ifnm:(BUFIN(INCR+JKJ))PQ(II)=BUFIN(INCR+JKJ)# If the number exists      AR04 285
ELSE                  PQ(II)=1.0#      Else store default of 1.0        AR04 286
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 AR04 287
ELSE             PQ(II)=QX(IPAK+JKJ)#  Store bdf input rcode            AR04 288
K=NINT(PQ(II)); COUNT(K)=COUNT(K)+1.#  Count rcodes                     AR04 289
IF(PQ(II)>JMAX)#                       Disallowed value of rcod         AR04 290
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 AR04 291
REASON=5;   GOTO100#                   Set reason flag                  AR04 292
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 AR04 293
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 AR04 294
#                                                                       AR04 295
# DO FORM FACTORS                                                       AR04 296
# ---------------                                                       AR04 297
#                                                                       AR04 298
ELSE IF(IDN>500 & IDN<511)#            Test if form factor              AR04 299
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 AR04 300
I1=0#                                  First interpolation point        AR04 301
FOR(K=MARK3;K<ISTOP;K=K+12)#           Loop over table                  AR04 302
IF(STOL>=QX(K+1) & STOL<=QX(K+13)) I1=K-12# Calc stol interval          AR04 303
IF(I1==0)          I1=ISTOP-48#        Default last 4 points            AR04 304
IF(I1>ISTOP-48)    I1=ISTOP-48#        Again                            AR04 305
IF(I1<MARK3)       I1=MARK3#           Default first 4 points           AR04 306
SUM=0.;    JJ=IDN-500;   KK=I1+36#     Interpolated ff                  AR04 307
FOR(K=I1;K<=KK;K=K+12)#                Loop over 4 points               AR04 308
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 AR04 309
PROD=1.#                               Term of equation                 AR04 310
FOR(L=I1;L<=KK;L=L+12)#                Loop over 4 points               AR04 311
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 AR04 312
IF(K==L) NEXT#                         Skip if k=l                      AR04 313
PROD=PROD*(STOL-QX(L+1))/(QX(K+1)-QX(L+1))# Factor                      AR04 314
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 AR04 315
LL=K+JJ+2#                             Point to ff table                AR04 316
PROD=PROD*QX(LL)#                      Term                             AR04 317
SUM=SUM+PROD#                          Accumulate interpolated ff       AR04 318
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 AR04 319
PQ(II)=SUM#                            Store sum                        AR04 320
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 AR04 321
#                                                                       AR04 322
# DO ANYTHING ELSE                                                      AR04 323
# ----------------                                                      AR04 324
#                                                                       AR04 325
ELSE#                                  Whatever is left                 AR04 326
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 AR04 327
IF(IFIL>0)       PQ(II)=QX(IPAK+JKJ)#  If bdf input                     AR04 328
ELSE IF(IFIL==0) PQ(II)=BUFIN(INCR+JKJ)# Hkl lines input                AR04 329
IF(IPHI==J)      PQ(II)=PQ(II)/360.#   Convert phi to cycles            AR04 330
ELSE IF(IDN==309)#                     If scale group                   AR04 331
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 AR04 332
PQ(II)=MAX(1.,PQ(II))#                 Avoid zero scale group           AR04 333
IF(PQ(II)>SGRPMX \ PQ(II)<SGRPMN)#     Test outside grp limits          AR04 334
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 AR04 335
REASON=6; GO TO 100#                   Set reason and jump              AR04 336
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 AR04 337
ELSE IF(NINT(PQ(II))>NSCGRP) NSCGRP=NINT(PQ(II))# Reset scl grp max     AR04 338
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 AR04 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 AR04 340
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR04 341
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR04 342
#                                                                       AR04 343
# TEST FOR MAX AND MIN QUANTITIES                                       AR04 344
# -------------------------------                                       AR04 345
#                                                                       AR04 346
IWRITE=yes:#                           Made it through safely           AR04 347
DO K=1,3#                              Test for max hkl                 AR04 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 AR04 349
IF(HKL(K)>HKLMAX(K)) HKLMAX(K)=HKL(K)# Test for new max                 AR04 350
IF(HKL(K)<HKLMIN(K)) HKLMIN(K)=HKL(K)# Test for new min                 AR04 351
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 AR04 352
IF(STOL>STOLMX) STOLMX=STOL#           New max stol                     AR04 353
IF(STOL<STOLMN) STOLMN=STOL#           New min stol                     AR04 354
IF(FLOAT(EPS)>EPSLMX) EPSLMX=FLOAT(EPS)# Test for new max eps           AR04 355
IF(FLOAT(EPS)<EPSLMN) EPSLMN=FLOAT(EPS)# Test for new min eps           AR04 356
IF(FLOAT(MUL)>MULMAX) MULMAX=FLOAT(MUL)# Test for new max mul           AR04 357
IF(FLOAT(MUL)<MULMIN) MULMIN=FLOAT(MUL)# Test for new min mul           AR04 358
IF(FLOAT(PRC)>PRCMAX) PRCMAX=FLOAT(PRC)# Test for new max prc           AR04 359
IF(FLOAT(PRC)<PRCMIN) PRCMIN=FLOAT(PRC)# Test for new min prc           AR04 360
#                                                                       AR04 361
# WARN USER THAT REFLECTIONS ARE BEING REJECTED.                        AR04 362
#-----------------------------------------------                        AR04 363
#                                                                       AR04 364
100 CONTINUE#                                                           AR04 365
IF(IWRITE==yes:)#                      Only if last refl was ok         AR04 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 AR04 367
writepkt:(3,lrrefl:,PSIZE,IPP)#        **** writepkt ****               AR04 368
movereal:(PQ,1,QX,IPP+1,PSIZE,0)#      Fill the output buffer           AR04 369
COUNT(6)=COUNT(6)+1.#                  Count up refls                   AR04 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 AR04 371
ELSE#                                  Rejected reflection              AR04 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 AR04 373
IF(IGEN==yes:&REASON<4) NEXT#          Skip if data generated           AR04 374
I=(REASON-1)*7+1#                      Index reason for rejection       AR04 375
movechar:(AR043,I,AR042,37,7,0)#       Move reason to print             AR04 376
ncodefld:(HKL,1,AR042,FMT,3)#          Format h, k, l                   AR04 377
IF(PPRIOR>3\LIST==yes:\COUNT(7)<10.)#  List rejected reflections        AR04 378
writeline:(0,AR042,NAR042,3,3)#        List rej hkl                     AR04 379
COUNT(7)=COUNT(7)+1.#                  Count up rejected refls          AR04 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 AR04 381
IF(IGEN==yes:) NEXT#                   Skip if data generated           AR04 382
#                                                                       AR04 383
#   ENTER NEXT RECORD                                                   AR04 384
#   -----------------                                                   AR04 385
#                                                                       AR04 386
DO I=1,NFIL#                           Loop over files                  AR04 387
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 AR04 388
IFIL=FILE(I)#                          Extract file number              AR04 389
IF(IFIL>0)#                            Test for bdf input               AR04 390
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 AR04 391
readwpkt:(IFIL,lrrefl:,PSIZ,PAKPT(I),0)# **** readwpkt ****             AR04 392
IF((PAKPT(I)<=0)&(I!=1)) GOTO 200#     End of lr                        AR04 393
ELSE IF((PAKPT(I)<=0)&(I==1))#         Skip replica w/o lrrefl          AR04 394
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 AR04 395
IF(MARK(1)==MARK(2)) NEXT#             Go to next file                  AR04 396
ELSE                 GOTO 200#         Get out of here                  AR04 397
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 AR04 398
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 AR04 399
ELSE IF(IFIL==0)#                      Test for hkl lines               AR04 400
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 AR04 401
readline:(AR041,NAR041)#               Read hkl line                    AR04 402
IF(LINID==7) GOTO 200#                 Exit on end line                 AR04 403
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 AR04 404
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 AR04 405
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR04 406
#                                                                       AR04 407
#   FINISH OFF INPUT                                                    AR04 408
#   ----------------                                                    AR04 409
#                                                                       AR04 410
200 CONTINUE#                                                           AR04 411
IF(IFIL>0) readwpkt:(IFIL,endrecord:,I,I,0)# Close the diff file        AR04 412
REPEAT#                                Eat up remaining hkl line        AR04 413
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 AR04 414
IF(LINID!=7) readline:(AR041,NAR041)#  Read the next line               AR04 415
ELSE BREAK#                                                             AR04 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 AR04 417
#                                                                       AR04 418
RETURN#                                                                 AR04 419
END#                                                                    AR04 420
systemheader:(AR05)#                   Op lrscat, lrdset, lrrefl        AR05   1
##############################################################          AR05   2
#                                                            #          AR05   3
#                         AR05                               #          AR05   4
#                                                            #          AR05   5
##############################################################          AR05   6
SUBROUTINE AR05#                                                        AR05   7
include:(AACOMN)#                                                       AR05   8
include:(ARCOMN)#                                                       AR05   9
#                                                                       AR05  10
REAL DATSET,CC#                        Current data set no.             AR05  11
INTEGER ICOL#                          Column number                    AR05  12
INTEGER IWANT(50)#                                                      AR05  13
INTEGER KEY(4)#                                                         AR05  14
INTEGER WNTMX#                         Maximum items wanted             AR05  15
INTEGER I,II,J,JJ,IP,JP#               Misc pointers                    AR05  16
INTEGER NSCL#                          Number of scales                 AR05  17
#                                                                       AR05  18
string:(TEMP,40)#                                                       AR05  19
chardata:(PROC,"powder Lp applied        No monochr Lp applied    $#    AR05  20
perpendicular monochr Lp equatorial monochr Lp    ")#                   AR05  21
chardata:(AR051," Output file contains -- item idnum       $#           AR05  22
max        min")#                                                       AR05  23
chardata:(AR052,"h   k   l   stolepslmultphir")#                        AR05  24
chardata:(AR053," Output file contains         reflections")#           AR05  25
chardata:(AR054,FF1 FF2 FF3 FF4 FF5 FF6 FF7 FF8 FF9 FF10)#              AR05  26
chardata:(AR05A,"   h  k  l  stol mul eps prc")#                        AR05  27
chardata:(AR057,"                              with rcode=    ")#       AR05  28
chardata:(AR058," Rejected from input          reflections")#           AR05  29
realdata:(DIR,[1.,1.,1.,2.,3.,3.])#                                     AR05  30
realdata:(FMT,[350413.,460942.,570942.])#                               AR05  31
intdata:(ICOLMX,120)#                                                   AR05  32
intdata:(MXITUM,6)#                                                     AR05  33
intdata:(ICOL1,[8,6,7,7,7,7,7,8,7,4,4,6,4,5,5,4,4,5,6,6,6,#             AR05  34
7,7,8,6,8,6,4,4])#                                                      AR05  35
intdata:(ICOL2,[822,622,722,722,722,731,731,822,722,213,313,#           AR05  36
621,422,522,522,422,313,532,621,621,621,731,731,822,622,822,#           AR05  37
622,213,313])#                                                          AR05  38
datastuff:#                                                             AR05  39
#                                                                       AR05  40
# GET READY FOR SECOND PASS                                             AR05  41
# -------------------------                                             AR05  42
#                                                                       AR05  43
DO I=1,2#                              Clear reduced f stats            AR05  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR05  45
OUTMAX(I)=-99999.#                     Initial max outdat               AR05  46
OUTMIN(I)= 99999.#                     Initial min outdat               AR05  47
SIGMAX(I)=-99999.#                     Initial max sigma out            AR05  48
SIGMIN(I)= 99999.#                     Initial min sigma out            AR05  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR05  50
readwpkt:(1,endrecord:,PSIZE,IP,0)#                                     AR05  51
writepkt:(3,endrecord:,PSIZE,IP)#      End scratch file                 AR05  52
copyfile:(1,2,1,decr:(lrscat:))#       Copy up to lrscat:               AR05  53
#                                                                       AR05  54
# PUT FLAG INTO LRSCAT:                                                 AR05  55
# ---------------------                                                 AR05  56
#                                                                       AR05  57
IWANT(1)=7#                            Request flag                     AR05  58
KEY(1)=1#                              Mandatory                        AR05  59
KEY(2)=0#                              No optional items                AR05  60
KEY(3)=0#                              No additions or deletions        AR05  61
KEY(4)=0#                              Non-archive mode                 AR05  62
indexpkt:(1,lrscat:,PSIZE,IP,2,KEY,IWANT,IREL)#                         AR05  63
IF(IREL(1)<=0) iquit:(AR0502)#         Quit or later progs will cro     AR05  64
REPEAT#                                Loop over lrscat packets         AR05  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR05  66
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read dset1 pkt                   AR05  67
IF(IP<=0) BREAK#                       End of lr                        AR05  68
writepkt:(2,lrscat:,PSIZE,JP)#         Write packet                     AR05  69
movereal:(QX,IP+1,QX,JP+1,PSIZE,1)#    Transfer packet                  AR05  70
II=JP+IREL(1)#                         Point to flag                    AR05  71
IF(FFAC==yes:) QX(II)=1.0#             Form factors inserted            AR05  72
ELSE           QX(II)=0.0#             Form factors not inserted        AR05  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR05  74
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))#                           AR05  75
#                                                                       AR05  76
# INSERT RADIATION WAVELENGTH AND GROUP SCALE SLOTS                     AR05  77
# -------------------------------------------------                     AR05  78
#                                                                       AR05  79
IWANT(1)=1 ; IWANT(2)=2 ; IWANT(3)=100# Data set wavelength, no. sgp    AR05  80
DO I=1,NSCGRP; IWANT(I+3)=I+100#       Request position of scales       AR05  81
IWANT(NSCGRP+4)=50; IWANT(NSCGRP+5)=51# Ids for monochrom 2t & pfac     AR05  82
IWANT(NSCGRP+6)=52; IWANT(NSCGRP+7)=57# Polar. ratio xtal/source        AR05  83
NSCL=NSCGRP+7#                         Mark end of scales               AR05  84
IWANT(NSCL+1)=507;  IWANT(NSCL+2)=508# Request theta min and max        AR05  85
DO I=1,mxwd40c:; IWANT(NSCL+I+2)=515#  String for reduct process        AR05  86
KEY(1)=1 ; KEY(2)=1 ; KEY(3)=NSCL+mxwd40c:+2; KEY(4)=0# Make room       AR05  87
indexpkt:(1,lrexpl:,PSIZE,IP,2,KEY,IWANT,IREL)# Get the pointers        AR05  88
IF(IRLP>0&IRLP<5) TEMP=PROC(IRLP*25-24^IRLP*25)# Store lp applied       AR05  89
ELSE              TEMP=' '#            Leave blank                      AR05  90
IF(STOLMN>STOLMX&STOLMN*LAMBDA>1.0)#   Sin theta is > 1                 AR05  91
iquit:(AR0505)#                        Something is wrong so quit       AR05  92
#                                                                       AR05  93
REPEAT#                                Loop over all data sets          AR05  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR05  95
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Point to ip packet               AR05  96
IF(IP<=0) BREAK#                       Until all data sets treated      AR05  97
writepkt:(2,lrexpl:,KEY(4),JP)#        Point to op packet               AR05  98
movereal:(voidflg:,1,QX,JP+1,KEY(4),2)# Set output field to voids       AR05  99
movereal:(QX,IP+1,QX,JP+1,PSIZE,0)#    Move input stuff                 AR05 100
DATSET=QX(JP+IREL(1))*1000.#           Build proper dataset             AR05 101
ifne:(DSNM,DATSET) NEXT#               Check for wanted datax set       AR05 102
QX(JP+IREL(2))=LAMBDA#                 Store current wavelength         AR05 103
QX(JP+IREL(3))=FLOAT(NSCGRP)#          Store current no. of scales      AR05 104
DO I=1,NSCGRP#                         Fill group scale slots           AR05 105
ifvo:(QX(JP+IREL(I+3))) QX(JP+IREL(I+3))=1.0# Change voids to 1.0       AR05 106
IF(IRLP<7\IREL(NSCGRP+4)>PSIZE)#       Is this a new value              AR05 107
QX(JP+IREL(NSCGRP+4))=ACOS(MONO2T)/.01745329# Store 2 theta in degr     AR05 108
IF(IRLP<7\IREL(NSCGRP+5)>PSIZE)#       Is this a new value              AR05 109
QX(JP+IREL(NSCGRP+5))=MONOPF#          Store monochrom perf factor      AR05 110
IF(IRLP<7\IREL(NSCGRP+6)>PSIZE)#       Is this a new value              AR05 111
QX(JP+IREL(NSCGRP+6))=PPFAC#           Polar factor on crystal          AR05 112
IF(IRLP<7\IREL(NSCGRP+7)>PSIZE)#       Is this a new value              AR05 113
QX(JP+IREL(NSCGRP+7))=POLFR#           Source polar factor              AR05 114
QX(JP+IREL(NSCL+1))=57.296*ASIN(STOLMN*LAMBDA)# Store theta min         AR05 115
QX(JP+IREL(NSCL+2))=57.296*ASIN(STOLMX*LAMBDA)# Store theta max         AR05 116
movector:(TEMP,1,QX(JP+IREL(NSCL+3)),1,40,0)# Store reduction proces    AR05 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR05 118
copyfile:(1,2,incr:(lrexpl:),decr:(lrdset:))#                           AR05 119
#                                                                       AR05 120
# INSERT MAX AND MIN QUANTITIES INTO LRDSET:                            AR05 121
# ------------------------------------------                            AR05 122
#                                                                       AR05 123
CC=0.; DO I=1,5; CC=CC+COUNT(I)#       Count all rcodes                 AR05 124
IF(CC<small:) COUNT(1)=COUNT(6)#       All rcodes are assumed 1.        AR05 125
IWANT(1)=11; IWANT(2)=12; IWANT(3)=13# Request max /h/ /k/ /l/          AR05 126
IWANT(4)=14; IWANT(5)=15#              Request min/max stol             AR05 127
DO I=1,16; IWANT(I+5)=I+70#            Request measured hkls limits     AR05 128
KEY(1)=0; KEY(2)=0; KEY(3)=21; KEY(4)=0# Set search keys                AR05 129
indexpkt:(1,lrdset:,PSIZE,IP,2,KEY,IWANT,IREL)# Point to wants          AR05 130
REPEAT#                                Loop over all data sets          AR05 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR05 132
readwpkt:(1,lrdset:,PSIZE,IP,0)#       Point to input packet            AR05 133
IF(IP<=0) BREAK#                       Until all data sets treated      AR05 134
writepkt:(2,lrdset:,KEY(4),JP)#        Point to output packet           AR05 135
movereal:(QX,IP+1,QX,JP+1,PSIZE,1)#    Transfer ip to op                AR05 136
IF(LIMITS==no:\PSIZE<KEY(4))#          Test to reset maxhkl             AR05 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR05 138
DO I=1,3#                              Loop over hkl                    AR05 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR05 140
II=JP+IREL(I);  QX(II)=MAX(HKLMAX(I),ABS(HKLMIN(I)))# Calc max hkl      AR05 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR05 142
II=JP+IREL(4);  QX(II)=STOLMN#         Store min stol                   AR05 143
II=JP+IREL(5);  QX(II)=STOLMX#         Store max stol                   AR05 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR05 145
QX(JP+IREL( 6))=HKLMIN(1)#             Store min h                      AR05 146
QX(JP+IREL( 7))=HKLMAX(1)#             Store max h                      AR05 147
QX(JP+IREL( 8))=HKLMIN(2)#             Store min k                      AR05 148
QX(JP+IREL( 9))=HKLMAX(2)#             Store max k                      AR05 149
QX(JP+IREL(10))=HKLMIN(3)#             Store min l                      AR05 150
QX(JP+IREL(11))=HKLMAX(3)#             Store max l                      AR05 151
QX(JP+IREL(12))=57.296*ASIN(STOLMN*LAMBDA)# Store theta min             AR05 152
QX(JP+IREL(13))=57.296*ASIN(STOLMX*LAMBDA)# Store theta max             AR05 153
QX(JP+IREL(14))=0.5/STOLMX#            Store hi resolution d            AR05 154
QX(JP+IREL(15))=0.5/STOLMN#            Store lo resolution d            AR05 155
QX(JP+IREL(16))=COUNT(6)#              Total reflections input          AR05 156
DO I=1,5; QX(JP+IREL(I+16))=COUNT(I)#  Store counts per rcode           AR05 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR05 158
DO I=1,6; COUNT(I)=0.#                 Reset rejection count            AR05 159
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))# Copy up to lrrefl         AR05 160
#                                                                       AR05 161
# SETUP LRREFL: DIRECTORY PACKET                                        AR05 162
# ------------------------------                                        AR05 163
#                                                                       AR05 164
IWANT(1)=1#                            Request hkl                      AR05 165
IWANT(2)=2#                            Request stol                     AR05 166
IWANT(3)=3#                            Request emul                     AR05 167
IWANT(4)=INDAT#                        Input data                       AR05 168
IWANT(5)=IWANT(4)+1#                   Sigma input                      AR05 169
IWANT(6)=OUTDAT#                       Output data                      AR05 170
IWANT(7)=IWANT(6)+1#                   Sigma output                     AR05 171
IWANT(8)=NINT(DSNM)+308#               Request rcod                     AR05 172
IWANT(9)=NINT(DSNM)+204#               Request 1/lp                     AR05 173
WNTMX=9#                               No friedel pairs                 AR05 174
IF(IFRIED==2)#                         But are there...                 AR05 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR05 176
IWANT(10)=IWANT(4)+10#                 See structure of lrrefl:         AR05 177
IWANT(11)=IWANT(5)+10#                 In programmers manual            AR05 178
IWANT(12)=IWANT(6)+10#                                                  AR05 179
IWANT(13)=IWANT(7)+10#                                                  AR05 180
WNTMX=13#                              Get -h,-k,-l too                 AR05 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR05 182
DO I=1,WNTMX ; IREL(I)=0#              Initialize irel                  AR05 183
readwpkt:(3,lrrefl:,PSIZE,NPUTPK,0)#   Read directory                   AR05 184
MARK5=ISTOP#                           Flags                            AR05 185
incrqx:(ISTOP,ISTOP+2*PSIZE,AR0501)#   Space for flags                  AR05 186
FOR(I=MARK5+1;I<=MARK5+PSIZE;I=I+1)#   Loop over flags                  AR05 187
QX(I)=1.0#                             Initialize                       AR05 188
DO I=1,WNTMX#                          Loop over want list              AR05 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR05 190
FOR(J=NPUTPK+1;J<=NPUTPK+PSIZE;J=J+1)# Loop over directory              AR05 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR05 192
IF(IWANT(I)==NINT(QX(J)))#             Found item                       AR05 193
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR05 194
IREL(I)=J-NPUTPK#                      Store irel                       AR05 195
BREAK#                                 Once found its found             AR05 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR05 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR05 198
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR05 199
IF(IREL(4)<=0)#                        Indat not there                  AR05 200
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR05 201
II=MARK5+IREL(6)#                      Point to outdat flag             AR05 202
QX(II)=0.0#                            Flag for removal                 AR05 203
IOUT=no:#                              No point in doing 1/lp           AR05 204
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR05 205
IF(IREL(5)<=0)#                        Sigma in not there               AR05 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR05 207
II=MARK5+IREL(7)#                      Point to sigma out flag          AR05 208
QX(II)=0.0#                            Flag for removal                 AR05 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR05 210
IF(IFRIED==2)#                         Friedel pairs...                 AR05 211
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR05 212
IF(IREL(10)<=0)#                       Friedel related intensity        AR05 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR05 214
IFRIED=1#                              Kill friedel                     AR05 215
II=MARK5+IREL(12)#                     Point to friedel outdat          AR05 216
QX(II)=0.0#                            Flag for removal                 AR05 217
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR05 218
IF(IREL(11)<=0)#                       Friedel related sigmas           AR05 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR05 220
II=MARK5+IREL(13)#                     Point to friedel outdat          AR05 221
QX(II)=0.0#                            Flag for removal                 AR05 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR05 223
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR05 224
#                                                                       AR05 225
# SET UP FLAGS TO SEE IF REMOVALS ARE NECESSARY                         AR05 226
# ---------------------------------------------                         AR05 227
#                                                                       AR05 228
IF(FILE(NFIL)<0&FILE(NFIL)>-1000)#     Removals present                 AR05 229
FOR(I=MARK(NFIL);I<MARK(NFIL+1);I=I+1)# Loop over removals              AR05 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR05 231
FOR(J=1;J<=PSIZE;J=J+1)#               Loop over flags                  AR05 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AR05 233
II=NPUTPK+J#                           Point to pkt element             AR05 234
JJ=MARK5+J#                            Point to flag                    AR05 235
ifeq:(QX(II),idnm:(I)) QX(JJ)=0.0#     Flag removals                    AR05 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AR05 237
FOR(J=MARK1;J<MK;J=J+6)#               Loop over all items              AR05 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AR05 239
ifeq:(pnto:(J),0.) NEXT#               Skip inactive items              AR05 240
ifeq:(idnm:(I),idnm:(J))#              Removal in list                  AR05 241
pnto:(J)=0.0#                          Flag thusly                      AR05 242
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AR05 243
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR05 244
II=0#                                  Op pkt size                      AR05 245
FOR(I=MARK5+1;I<=MARK5+PSIZHO;I=I+1)#  Loop over flags                  AR05 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AR05 247
ifeq:(QX(I),1.0)#                      Flag on                          AR05 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AR05 249
II=II+1#                                                                AR05 250
QX(I)=FLOAT(II)#                       Store op position                AR05 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AR05 252
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AR05 253
PSIZO=II#                              Output packet size               AR05 254
#                                                                       AR05 255
# PREPARE LIST HEADING                                                  AR05 256
# --------------------                                                  AR05 257
#                                                                       AR05 258
movechar:(BLANK,1,AR055,1,132,1)#      Blank heading                    AR05 259
NAR055=NAR05A#                                                          AR05 260
movechar:(AR05A,1,AR055,1,NAR05A,0)#                                    AR05 261
IF((IOUT==no:)\(LPINS==yes:)) ICOL=NAR055# No rlp added                 AR05 262
ELSE#                                  Rlp                              AR05 263
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AR05 264
ICOL=NAR055+6#                         Room for rlp                     AR05 265
movechar:(AR023,73,AR055,ICOL-2,4,0)#  Move name                        AR05 266
NAR055=NAR055+4#                       Add to heading chars             AR05 267
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AR05 268
FOR(I=4;I<=PSIZE;I=I+1)#               Loop over packet                 AR05 269
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AR05 270
II=NPUTPK+I#                           Point to idnum                   AR05 271
JJ=MARK5+I#                            Point to flag                    AR05 272
IF(QX(JJ)<=0.0)#                       Not flagged for output           AR05 273
ifne:(QX(II),INDAT)#                   Not indata                       AR05 274
ifne:(QX(II),INDAT+1.0)#               Not sigma indata                 AR05 275
ifne:(QX(II),INDAT+10.0)#              Not friedel indata               AR05 276
ifne:(QX(II),INDAT+11.0)#              Not sigma friedel indata         AR05 277
NEXT#                                  Skip to next item                AR05 278
DO J=2,MXITEM#                         Loop over dirn array             AR05 279
ifeq:(AMOD(QX(II),1000.),DIRN(J))#     Match                            AR05 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AR05 281
ICOL=ICOL+ICOL1(J-1)+1#                New ending column                AR05 282
IF(ICOL>ICOLMX) BREAK#                 End of page                      AR05 283
movechar:(AR023,4*(J-1)+1,AR055,ICOL-3,4,0)# Move name                  AR05 284
JJ=JJ+PSIZE#                           Point to format                  AR05 285
QX(JJ)=FLOAT(10000*ICOL+ICOL2(J-1))#   Format                           AR05 286
NAR055=ICOL#                           Reset end of heading             AR05 287
BREAK#                                 Go on to next item               AR05 288
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AR05 289
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AR05 290
#                                                                       AR05 291
# GO AND TREAT THE REFLECTIONS                                          AR05 292
# ----------------------------                                          AR05 293
#                                                                       AR05 294
CALL AR06#                                                              AR05 295
#                                                                       AR05 296
copyfile:(1,2,incr:(lrrefl:),endrecord:)#                               AR05 297
#                                                                       AR05 298
# SCAN ITEM LIST AND REPORT TO USER                                     AR05 299
# ---------------------------------                                     AR05 300
#                                                                       AR05 301
writeline:(1,AR051,NAR051,3,3)#        Output file contains...          AR05 302
#                                                                       AR05 303
# WRITE MAX H,K,L                                                       AR05 304
# ---------------                                                       AR05 305
#                                                                       AR05 306
DO I=1,3#                              Loop over h,k,l                  AR05 307
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AR05 308
movechar:(AR052,4*(I-1)+1,CHROT,26,1,0)# Move name                      AR05 309
BUFOT(1)=1.#                           Idnum                            AR05 310
BUFOT(2)=HKLMAX(I)#                    Max index                        AR05 311
BUFOT(3)=HKLMIN(I)#                    Min index                        AR05 312
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode to buffer                 AR05 313
writeline:(0,0,0,1,3)#                 Write line                       AR05 314
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AR05 315
#                                                                       AR05 316
# WRITE MAX AND MIN STOL                                                AR05 317
# ----------------------                                                AR05 318
#                                                                       AR05 319
movechar:(AR052,13,CHROT,26,4,0)#      Move name                        AR05 320
BUFOT(1)=2.#                           Idnum                            AR05 321
BUFOT(2)=STOLMX#                       Max stol                         AR05 322
BUFOT(3)=STOLMN#                       Min stol                         AR05 323
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode to buffer                 AR05 324
writeline:(0,0,0,1,3)#                                                  AR05 325
#                                                                       AR05 326
# WRITE MAX AND MIN EPSILON AND MULTIPLICITY                            AR05 327
# ------------------------------------------                            AR05 328
#                                                                       AR05 329
movechar:(AR052,21,CHROT,26,4,0)#      Move name                        AR05 330
BUFOT(1)=3.#                           Idnum                            AR05 331
BUFOT(2)=MULMAX#                       Max multiplicity                 AR05 332
BUFOT(3)=MULMIN#                       Min multiplicity                 AR05 333
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode line                      AR05 334
writeline:(0,0,0,1,3)#                 Write line                       AR05 335
movechar:(AR052,17,CHROT,26,4,0)#      Move name                        AR05 336
BUFOT(1)=3.#                           Idnum                            AR05 337
BUFOT(2)=EPSLMX#                       Max epsilon                      AR05 338
BUFOT(3)=EPSLMN#                       Min epsilon                      AR05 339
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode                           AR05 340
writeline:(0,0,0,1,3)#                 Write line                       AR05 341
movechar:(AR052,25,CHROT,26,4,0)#      Move name                        AR05 342
BUFOT(1)=3.#                           Idnum                            AR05 343
BUFOT(2)=PRCMAX#                       Max phase restriction            AR05 344
BUFOT(3)=PRCMIN#                       Min phase restriction            AR05 345
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode                           AR05 346
writeline:(0,0,0,1,3)#                 Print phase restriction          AR05 347
#                                                                       AR05 348
# WRITE OUT REST OF ITEMS                                               AR05 349
# -----------------------                                               AR05 350
#                                                                       AR05 351
FOR(I=MARK1;I<MK;I=I+6)#               Loop over items                  AR05 352
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AR05 353
ifeq:(pnto:(I),0.) NEXT#               Skip items not used              AR05 354
IF(idnm:(I)<4.) NEXT#                  Skip hkl, stol, emul             AR05 355
ifeq:(idnm:(I),FLOAT(OUTDAT))#         Converted data                   AR05 356
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AR05 357
pmax:(I)=OUTMAX(1)#                    Store max outdat                 AR05 358
pmin:(I)=OUTMIN(1)#                    Store min outdat                 AR05 359
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AR05 360
ELSE ifeq:(idnm:(I),FLOAT(OUTDAT+1))#  Converted sigma                  AR05 361
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 AR05 362
IF(IREL(5)<=0) NEXT#                   Sig indat not there              AR05 363
pmax:(I)=SIGMAX(1)#                    Store max sig out                AR05 364
pmin:(I)=SIGMIN(1)#                    Store min sig out                AR05 365
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 AR05 366
ELSE ifeq:(idnm:(I),FLOAT(OUTDAT+10))# Converted data                   AR05 367
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AR05 368
pmax:(I)=OUTMAX(2)#                    Store max outdat                 AR05 369
pmin:(I)=OUTMIN(2)#                    Store min outdat                 AR05 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AR05 371
ELSE ifeq:(idnm:(I),FLOAT(OUTDAT+11))# Converted sigma                  AR05 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 AR05 373
IF(IREL(5)<=0) NEXT#                   Sig indat not there              AR05 374
pmax:(I)=SIGMAX(2)#                    Store max sig out                AR05 375
pmin:(I)=SIGMIN(2)#                    Store min sig out                AR05 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 AR05 377
BUFOT(1)=idnm:(I)#                     Idnum                            AR05 378
BUFOT(2)=pmax:(I)#                     Max parameter                    AR05 379
BUFOT(3)=pmin:(I)#                     Min parameter                    AR05 380
IF(idnm:(I)>999.)#                     Named items only                 AR05 381
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 AR05 382
DO J=1,MXITEM#                         Look again                       AR05 383
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 AR05 384
ifeq:(AMOD(idnm:(I),1000.),DIRN(J))#   Check other list                 AR05 385
movechar:(AR023,4*(J-1)+1,CHROT,26,4,0)# Write name                     AR05 386
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 AR05 387
DO J=1,MXITUM#                         Loop over dirn list              AR05 388
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 AR05 389
ifeq:(AMOD(idnm:(I),1000.),DIR(J))#    Look for name                    AR05 390
movechar:(AR052,4*(J-1)+1,CHROT,26,4,0)# Move name                      AR05 391
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 AR05 392
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 AR05 393
ELSE IF((idnm:(I)>500.)&(idnm:(I)<511.))# Form factor                   AR05 394
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 AR05 395
II=NINT(idnm:(I)-500.)#                Ff number                        AR05 396
movechar:(AR054,4*(II-1)+1,CHROT,26,4,0)# Move name                     AR05 397
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 AR05 398
ncodefld:(BUFOT,1,CHROT,FMT,3)#        Encode line                      AR05 399
writeline:(0,0,0,1,3)#                 Write line                       AR05 400
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AR05 401
#                                                                       AR05 402
# WRITE COUNT OF REFLECTIONS                                            AR05 403
# --------------------------                                            AR05 404
#                                                                       AR05 405
ncodefld:(COUNT,6,AR053,290613.,1)#    Encode nref                      AR05 406
writeline:(1,AR053,NAR053,3,3)#        Write line                       AR05 407
DO I=1,5#                              Loop over rcodes                 AR05 408
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 AR05 409
IF(COUNT(I)<0.5) NEXT#                 Skip zeros                       AR05 410
ncodefld:(FLOAT(I),1,AR057,420213.,1)# Encode rcod                      AR05 411
movechar:(BLANK,1,AR057,28,2,0)#       Blanks                           AR05 412
ncodefld:(COUNT,I,AR057,290613.,1)#    Encode count                     AR05 413
writeline:(0,AR057,NAR057,3,3)#        Write line                       AR05 414
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 AR05 415
ncodefld:(COUNT,7,AR058,290613.,1)#    Write rejected refls             AR05 416
writeline:(0,AR058,NAR058,3,3)#                                         AR05 417
#                                                                       AR05 418
RETURN#                                                                 AR05 419
END#                                                                    AR05 420
#                                                                       AR05 421
systemheader:(AR06)#                   Process reflection data          AR06   1
##############################################################          AR06   2
#                                                            #          AR06   3
#                         AR06                               #          AR06   4
#                                                            #          AR06   5
##############################################################          AR06   6
SUBROUTINE AR06#                                                        AR06   7
include:(AACOMN)#                                                       AR06   8
include:(ARCOMN)#                                                       AR06   9
#                                                                       AR06  10
REAL MON2T2#                           Monochrometer 2 theta **2        AR06  11
REAL SINT#                             Sin theta                        AR06  12
REAL SINTSQ#                                                            AR06  13
REAL COSS2T#                           Cosine(two theta) squared        AR06  14
REAL SIN2T#                            Sine(two theta)                  AR06  15
REAL RLP#                              1/lp                             AR06  16
REAL T1,T2#                                                             AR06  17
INTEGER RCOD#                          Rcode pointer                    AR06  18
INTEGER I,II,ITEMP,JKL#                Pointers                         AR06  19
INTEGER IFR#                           Friedel counter                  AR06  20
INTEGER IJ,IP,IPP,J,JP1,JP2#           More ruddy pointers              AR06  21
INTEGER KK,JP,JJ#                                                       AR06  22
#                                                                       AR06  23
chardata:(AR06B,"void")#                                                AR06  24
realdata:(BAYF,[0.47,0.49,0.52,0.55,0.58,0.61,0.65,0.70,0.76,0.81,#     AR06  25
0.89,0.97,1.06,1.17,1.27,1.37,1.48,1.59,1.69,1.80,0.30,0.32,#           AR06  26
0.34,0.36,0.38,0.41,0.43,0.48,0.52,0.57,0.65,0.74,0.82,0.95,#           AR06  27
1.08,1.21,1.34,1.48,1.62,1.73])#                                        AR06  28
realdata:(BAYS,[0.24,0.25,0.26,0.27,0.28,0.29,0.31,0.32,0.33,0.35,#     AR06  29
0.36,0.37,0.38,0.38,0.37,0.36,0.34,0.32,0.31,0.29,0.23,0.24,#           AR06  30
0.25,0.26,0.27,0.29,0.31,0.33,0.35,0.37,0.39,0.41,0.44,0.46,#           AR06  31
0.46,0.45,0.42,0.39,0.35,0.31])#                                        AR06  32
realdata:(FMT1,[40313.,70313.,100313.,160542.,200313.,240313.,#         AR06  33
280313.])#                                                              AR06  34
intdata:(IP1,0)#                                                        AR06  35
intdata:(IP2,0)#                                                        AR06  36
intdata:(IIP1,0)#                                                       AR06  37
intdata:(IIP2,0)#                                                       AR06  38
datastuff:#                                                             AR06  39
#                                                                       AR06  40
#                                                                       AR06  41
# MAKE INITIAL CALL TO WRITE REFLECTION RECORD HEADER PACKET            AR06  42
# FROM INPUT BUFFER TO OUTPUT BUFFER.  NPUTPK SET IN AR05.              AR06  43
# ---------------------------------------------------------             AR06  44
#                                                                       AR06  45
MON2T2=MONO2T**2#                      Square monochrometer angle       AR06  46
writepkt:(2,lrrefl:,PSIZO,JP)#         Writepkt                         AR06  47
writeline:(0,0,0,1,3)#                 Write some blank lines           AR06  48
LINRM=4#                               For header                       AR06  49
#                                                                       AR06  50
# LOOP OVER REFLECTIONS                                                 AR06  51
# ---------------------                                                 AR06  52
#                                                                       AR06  53
REPEAT#                                Loop over reflections            AR06  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  AR06  55
FOR(I=1;I<=PSIZE;I=I+1)#               Loop over packet contents        AR06  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  AR06  57
II=NPUTPK+I#                           Point pkt element                AR06  58
JJ=MARK5+I#                            Point to flag                    AR06  59
IF(QX(JJ)>0.0)#                        Op flag yes                      AR06  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  AR06  61
KK=JP+NINT(QX(JJ))#                    Output pointer                   AR06  62
movereal:(QX,II,QX,KK,1,1)#            Transfer item                    AR06  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  AR06  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  AR06  65
readwpkt:(3,lrrefl:,PSIZE,NPUTPK,0)#   Read refl packet                 AR06  66
IF(NPUTPK<=0) BREAK#                   Break at end of lr               AR06  67
IF(IREL(8)>0)#                         Rcod present                     AR06  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  AR06  69
II=NPUTPK+IREL(8)#                     Point to rcod                    AR06  70
ifvo:(QX(II)) QX(II)=4.#               Ignore reflection                AR06  71
RCOD=NINT(QX(II))#                     Rcod                             AR06  72
COUNT(RCOD)=COUNT(RCOD)+1.0#           Count reflection                 AR06  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  AR06  74
COUNT(6)=COUNT(6)+1.0#                 Count every reflection           AR06  75
writepkt:(2,lrrefl:,PSIZO,JP)#         Write pkt                        AR06  76
#                                                                       AR06  77
# SET UP POINTERS TO PRESERVE I, SIGI FOR PRINT EVEN IF                 AR06  78
# 1/LP NOT BEING TREATED.  FRIEDEL MUST BE PROVIDED FOR AS WELL         AR06  79
# -------------------------------------------------------------         AR06  80
#                                                                       AR06  81
IIP1=NPUTPK+IREL(4);   IIP2=NPUTPK+IREL(5)#                             AR06  82
IP1=NPUTPK+IREL(10);   IP2=NPUTPK+IREL(11)# F,f2,i  and sigma           AR06  83
#                                                                       AR06  84
IF(IOUT!=0)#                           If data conversion needed        AR06  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  AR06  86
II=NPUTPK+IREL(2)#                     Point to stol                    AR06  87
SINT=QX(II)*LAMBDA#                    Make sin(theta)                  AR06  88
SINTSQ=SINT*SINT#                      Sin(theta) squared               AR06  89
COSS2T =(1.-2.*SINTSQ)**2#             Cos(2theta) squared              AR06  90
SIN2T=SQRT(1.0-COSS2T)#                Sine of two theta                AR06  91
#                                                                       AR06  92
# CALCULATE 1/LP IF NEEDED                                              AR06  93
# ------------------------                                              AR06  94
#                                                                       AR06  95
# POWDER                                                                AR06  96
# ------                                                                AR06  97
#                                                                       AR06  98
IF(IRLP==1) RLP=2.0*SINT*SIN2T/(1.0+COSS2T)# Powder xray                AR06  99
#                                                                       AR06 100
# SPECTROMETER WITH EULERIAN CRADLE GEOMETRY AND 2THETA SCAN            AR06 101
# ----------------------------------------------------------            AR06 102
#                                                                       AR06 103
ELSE IF(IRLP==2)#                      As above                         AR06 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  AR06 105
RLP=2.*SIN2T/(1.+COSS2T)#                                               AR06 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  AR06 107
#                                                                       AR06 108
# DIFFRACTOMETER WITH PERPENDICULAR MONOCHROMATOR SETTING               AR06 109
# -------------------------------------------------------               AR06 110
#                                                                       AR06 111
ELSE IF(IRLP==3)#                      As above                         AR06 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  AR06 113
#  T1=(1.0-MONOPF)*(COSS2T+MON2T2)/(1.+MON2T2)#                         AR06 114
#  T2=MONOPF*(COSS2T+MONO2T)/(1.+MONO2T)#                               AR06 115
#  RLP=SIN2T/(T1+T2)#                     CALC RECIP LP                 AR06 116
T1=(POLFR*COSS2T+(1.-POLFR)*MON2T2)/(POLFR+(1.-POLFR)*MON2T2)#          AR06 117
T2=(POLFR*COSS2T+(1.-POLFR)*MONO2T)/(POLFR+(1.-POLFR)*MONO2T)#          AR06 118
RLP=SIN2T/((1.-MONOPF)*T1+MONOPF*T2)#  Calc recip lp                    AR06 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  AR06 120
#                                                                       AR06 121
# DIFFRACTOMETER WITH EQUATORIAL MONOCHROMATOR SETTING                  AR06 122
# ----------------------------------------------------                  AR06 123
#                                                                       AR06 124
ELSE IF(IRLP==4)#                      As above                         AR06 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  AR06 126
#  T1=(1.0-MONOPF)*(1.+COSS2T*MON2T2)/(1.+MON2T2)#                      AR06 127
#  T2=MONOPF*(1.+COSS2T*MONO2T)/(1.+MONO2T)#                            AR06 128
#  RLP=SIN2T/(T1+T2)#                     CALC RECIP LP                 AR06 129
T1=(POLFR+(1.-POLFR)*COSS2T*MON2T2)/(POLFR+(1.-POLFR)*MON2T2)#          AR06 130
T2=(POLFR+(1.-POLFR)*COSS2T*MONO2T)/(POLFR+(1.-POLFR)*MONO2T)#          AR06 131
RLP=SIN2T/((1.-MONOPF)*T1+MONOPF*T2)#  Calc recip lp                    AR06 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  AR06 133
#                                                                       AR06 134
# FUTURE 1/LP CORRECTIONS GO HERE                                       AR06 135
# -------------------------------                                       AR06 136
#                                                                       AR06 137
ELSE IF(IRLP==5) iquit:(AR0603)#       A                                AR06 138
ELSE IF(IRLP==6) iquit:(AR0603)#       A                                AR06 139
ELSE RLP=1.0#                          If none make one.                AR06 140
#                                                                       AR06 141
# ADJUST FOR NEUTRON DATA                                               AR06 142
# -----------------------                                               AR06 143
#                                                                       AR06 144
IF(INEU==yes:)#                        Neutron data                     AR06 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  AR06 146
IF(IRLP==1)     RLP=2.0*SINT*SIN2T#    Powder                           AR06 147
ELSE IF(IRLP<7) RLP=2.0*SIN2T#         Other neutron modes              AR06 148
ELSE            RLP=1.0#               If no correction rlp=1           AR06 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  AR06 150
#                                                                       AR06 151
# PUT 1/LP TO THE FILE IF NEED BE                                       AR06 152
# -------------------------------                                       AR06 153
#                                                                       AR06 154
IF(IREL(9)>0)#                         If present in file               AR06 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 AR06 156
II=NPUTPK+IREL(9)#                     Get pointer to 1/lp              AR06 157
QX(II)=RLP#                            Put it in buffer                 AR06 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 AR06 159
#                                                                       AR06 160
# LOOP OVER FRIEDEL PAIRS AS SET UP IN AR01                             AR06 161
# -----------------------------------------                             AR06 162
#                                                                       AR06 163
FOR(IFR=1;IFR<=IFRIED;IFR=IFR+1)#                                       AR06 164
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 AR06 165
IF(IFR==1)#                                                             AR06 166
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 AR06 167
IP1=NPUTPK+IREL(4)#                    Indat pointer                    AR06 168
IP2=NPUTPK+IREL(5)#                    Sigma                            AR06 169
IIP1=IP1;IIP2=IP2#                     Save in case ifried=2            AR06 170
JP1=NPUTPK+IREL(6)#                    Outdat pointer                   AR06 171
JP2=NPUTPK+IREL(7)#                    Sigma out                        AR06 172
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 AR06 173
ELSE#                                                                   AR06 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 AR06 175
IP1=NPUTPK+IREL(10)#                   Indat pointer                    AR06 176
IP2=NPUTPK+IREL(11)#                   Sigma                            AR06 177
JP1=NPUTPK+IREL(12)#                   Outdat pointer                   AR06 178
JP2=NPUTPK+IREL(13)#                   Sigma out                        AR06 179
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 AR06 180
#                                                                       AR06 181
# PERFORM DATA CONVERSION IF REQUIRED                                   AR06 182
# -----------------------------------                                   AR06 183
#                                                                       AR06 184
ifvo:(QX(IP1))#                        If input f,f**2,i is void        AR06 185
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 AR06 186
QX(JP1)=voidflg:#                      Set f,f**2,i to void             AR06 187
QX(JP2)=voidflg:#                      Set sigf,f**2,i to void          AR06 188
NEXT#                                  Skip to next reflection          AR06 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 AR06 190
IF(IOUT==1)#                           I to f                           AR06 191
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 AR06 192
QX(JP1)=SQRT(AMAX1(QX(IP1)*RLP,0.))#   Convert                          AR06 193
IF(IP2!=NPUTPK)#                       Sigma output                     AR06 194
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 AR06 195
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 196
ELSE IF(QX(JP1)<small:&QX(IP2)<small:) QX(JP2)=0.# Set sigma to zero    AR06 197
ELSE IF(QX(IP1)>(3.*QX(IP2))\IBAY==no:)# I>3*sigi                       AR06 198
QX(JP2)=QX(IP2)*RLP/(QX(JP1)+SQRT(QX(IP2)*RLP+QX(JP1)**2))# Sigma f     AR06 199
ELSE#                                  Use bayesian stats               AR06 200
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 AR06 201
IF(QX(IP2)<small:) iquit:(AR0601)#     Protect divide                   AR06 202
IPP=MAX0(1,NINT((QX(IP1)/QX(IP2)+3.)*3.)+1)+ICNT*20# Table pointer      AR06 203
QX(JP1)=BAYF(IPP)*SQRT(QX(IP2)*RLP)#   Frel                             AR06 204
QX(JP2)=BAYS(IPP)*SQRT(QX(IP2)*RLP)#   Sigma frel                       AR06 205
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 AR06 206
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 AR06 207
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 AR06 208
#                                                                       AR06 209
ELSE IF(IOUT==2)#                      F to i                           AR06 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 AR06 211
QX(JP1)=QX(IP1)**2/RLP#                Convert                          AR06 212
IF(IP2!=NPUTPK)#                       If sigma i present               AR06 213
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 AR06 214
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 215
ELSE           QX(JP2)=2.*QX(IP2)*QX(IP1)/RLP# Sigma i                  AR06 216
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 AR06 217
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 AR06 218
#                                                                       AR06 219
ELSE IF(IOUT==3)#                      I to f2                          AR06 220
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 AR06 221
QX(JP1)=QX(IP1)*RLP#                   Convert                          AR06 222
IF(IP2!=NPUTPK)#                       If sigma present                 AR06 223
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 AR06 224
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 225
ELSE IF(QX(JP1)<small:&QX(IP2)<small:) QX(JP2)=0.# Set sigma to zero    AR06 226
ELSE IF(QX(IP1)>(3.*QX(IP2))\IBAY==no:)# I>3sigi or no bayes            AR06 227
QX(JP2)=QX(IP2)*RLP#                   Convert sigma                    AR06 228
ELSE#                                  Negative i                       AR06 229
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 AR06 230
IF(QX(IP2)<small:) iquit:(AR0601)#     Protect divide                   AR06 231
IPP=MAX0(1,NINT((QX(IP1)/QX(IP2)+3.)*3.)+1)+ICNT*20# Table pointer      AR06 232
QX(JP1)=(BAYF(IPP)**2)*QX(IP2)*RLP#    F2 bayesian                      AR06 233
QX(JP2)=BAYS(IPP)*SQRT(QX(IP2)*RLP)*2.*SQRT(QX(JP1))# Sig f2            AR06 234
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 AR06 235
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 AR06 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 AR06 237
#                                                                       AR06 238
ELSE IF(IOUT==4)#                      F2 to i                          AR06 239
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 AR06 240
QX(JP1)=QX(IP1)/RLP#                   Convert                          AR06 241
IF(IP2!=NPUTPK)#                       Convert sigma                    AR06 242
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 AR06 243
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 244
ELSE           QX(JP2)=QX(IP2)/RLP#    Convert sigma                    AR06 245
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 AR06 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 AR06 247
#                                                                       AR06 248
ELSE IF(IOUT==5)#                      F2 to f                          AR06 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 AR06 250
QX(JP1)=SQRT(AMAX1(QX(IP1),0.0))#      Convert                          AR06 251
IF(IP2!=NPUTPK)#                       Convert sigma                    AR06 252
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 AR06 253
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 254
ELSE IF(QX(JP1)<small:&QX(IP2)<small:) QX(JP2)=0.# Set sigma to zero    AR06 255
ELSE QX(JP2)=QX(IP2)/(QX(JP1)+SQRT(QX(IP2)+QX(JP1)**2))# Sigma f        AR06 256
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 AR06 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 AR06 258
#                                                                       AR06 259
ELSE IF(IOUT==6)#                      F to f2                          AR06 260
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 AR06 261
QX(JP1)=QX(IP1)**2#                    Convert                          AR06 262
IF(IP2!=NPUTPK)#                       Convert sigma                    AR06 263
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 AR06 264
ifvo:(QX(IP2)) QX(JP2)=voidflg:#       Sigma is unknown                 AR06 265
ELSE           QX(JP2)=2.*QX(IP1)*QX(IP2)# Convert sigma                AR06 266
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 AR06 267
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 AR06 268
#                                                                       AR06 269
IF(QX(JP1)>OUTMAX(IFR)) OUTMAX(IFR)=QX(JP1)# New max(ifr) outdata       AR06 270
IF(QX(JP1)<OUTMIN(IFR)) OUTMIN(IFR)=QX(JP1)# New min(ifr) outdata       AR06 271
IF(IP2!=NPUTPK & QX(JP2)>voidflg:)#    Sigma present                    AR06 272
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 AR06 273
IF(QX(JP2)>SIGMAX(IFR)) SIGMAX(IFR)=QX(JP2)# New max(ifr) sigma out     AR06 274
IF(QX(JP2)<SIGMIN(IFR)) SIGMIN(IFR)=QX(JP2)# New min(ifr) sigma out     AR06 275
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 AR06 276
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 AR06 277
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  AR06 278
#                                                                       AR06 279
#  LIST CONVERSIONS                                                     AR06 280
#  ----------------                                                     AR06 281
#                                                                       AR06 282
IF((LIST==yes:)\(COUNT(6)<PRINT))#     If listing desired               AR06 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 AR06 284
gethkl:(NPUTPK+IREL(1),BUFOT)#         Get hkl                          AR06 285
IJ=NPUTPK+IREL(2)#                     Point to stol                    AR06 286
BUFOT(4)=QX(IJ)#                       Stol                             AR06 287
IJ=NPUTPK+IREL(3)#                     Point to packed mul eps prc      AR06 288
intunpak:(QX(IJ),ITEMP,0,5)#           Get mult                         AR06 289
BUFOT(5)=FLOAT(ITEMP)#                 Float and store mult             AR06 290
intunpak:(QX(IJ),ITEMP,5,7)#           Get eps                          AR06 291
BUFOT(6)=FLOAT(ITEMP)#                 Float and store eps              AR06 292
intunpak:(QX(IJ),ITEMP,12,4)#          Get prc                          AR06 293
BUFOT(7)=FLOAT(ITEMP)#                 Float and store prc              AR06 294
ncodefld:(BUFOT,1,CHROT,FMT1,7)#       Encode up to here                AR06 295
IF((IOUT!=no:)&(LPINS==no:))#          Rlp present                      AR06 296
ncodefld:(RLP,1,CHROT,340542.,1)#      Encode rlp                       AR06 297
#NCODEFLD:(0.5/BUFOT(4),1,CHROT,800642.,1)# ENCODE D SPACING            AR06 298
#                                                                       AR06 299
FOR(I=4;I<=PSIZE;I=I+1)#               Loop over packet                 AR06 300
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 AR06 301
II=NPUTPK+I#                                                            AR06 302
JJ=MARK5+I#                            Point to flag                    AR06 303
KK=JJ+PSIZE#                           Point to format                  AR06 304
IF(QX(JJ)<=0.0)#                       Not flagged for output           AR06 305
IF(((II!=IP1)&(II!=IP2))$#             Not indat or sigma inda          AR06 306
&((II!=IIP1)&(II!=IIP2))) NEXT#        Skip to next item                AR06 307
IF(QX(KK)>0.0)#                        Positive format                  AR06 308
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 AR06 309
ifvo:(QX(II))#                         Look out for 'voids'             AR06 310
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 AR06 311
JJ=NINT(QX(KK)*.0001)-NAR06B#          Find proper column               AR06 312
movechar:(AR06B,1,CHROT,JJ,NAR06B,0)#  Write 'void'                     AR06 313
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 AR06 314
ELSE ncodefld:(QX,II,CHROT,QX(KK),1)#  Encode                           AR06 315
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 AR06 316
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 AR06 317
writeline:(0,AR055,NAR055,1,3)#        Write reflection data            AR06 318
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 AR06 319
#                                                                       AR06 320
# TAKE STATISTICS FOR SUMMARY                                           AR06 321
# ---------------------------                                           AR06 322
#                                                                       AR06 323
FOR(J=MARK1;J<MK;J=J+6)#               Loop over items                  AR06 324
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 AR06 325
ifeq:(pnto:(J),0.) NEXT#               Skip if not there                AR06 326
ifeq:(idnm:(J),FLOAT(OUTDAT)) NEXT#    Save for second pass             AR06 327
ifeq:(idnm:(J),FLOAT(OUTDAT+1)) NEXT#  Save for second pass             AR06 328
IF(idnm:(J)<3.5) NEXT#                 Skip hkl,stol,emul               AR06 329
JKL=NPUTPK+NINT(pnto:(J))#             Point to item in op pkt          AR06 330
IF(QX(JKL)<pmin:(J)) pmin:(J)=QX(JKL)# Store new minimum                AR06 331
IF(QX(JKL)>pmax:(J)) pmax:(J)=QX(JKL)# Store new maximum                AR06 332
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 AR06 333
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  AR06 334
readwpkt:(3,endrecord:,PSIZE,IP,0)#    Close off scratch                AR06 335
#                                       #                               AR06 336
RETURN#                                                                 AR06 337
END#                                                                    AR06 338
pmacro:([no:])#                        Purge xtal system macros         AR06 339
