systemheader:(LF    )#                                                  LF     1
####################################################################### LF     2
##      Copyright (C) 2000, The Xtal System, The University of        # LF     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # LF     4
## Distributed under the GNU General Public Licence as published by   # LF     5
## the Free Software Foundation, in the hope that it will be useful   # LF     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # LF     7
## for more details.                                                  # LF     8
#                                                                     # LF     9
#                        *** LISTFC ***                               # LF    10
#                                                                     # LF    11
#     PROGRAM FOR LISTING REFLECTION DATA IN A COMPACT FORMAT         # LF    12
#     SUITABLE FOR PUBLICATION AND HARD-COPY ARCHIVING.               # LF    13
#                                                                     # LF    14
####################################################################### LF    15
#                                                                       LF    16
include:(XMACRO)#                      Insert system macros             LF    17
#                                                                       LF    18
systemheader:(LF00)#                   List refls in compact format     LF00   1
# ################################################################## #  LF00   2
#                                                                    #  LF00   3
#                               LF00                                 #  LF00   4
#                                                                    #  LF00   5
# ################################################################## #  LF00   6
SUBROUTINE LF00#                       S.r. hall 1984                   LF00   7
include:(AACOMN)#                      S.r. hall 1990                   LF00   8
#                                                                       LF00   9
INTEGER I,J,K,L,M,N#                                                    LF00  10
INTEGER IR,IG,NPAK,IP,IS#                                               LF00  11
INTEGER IWNT(24),IREL(25),KEY(4)#                                       LF00  12
INTEGER ICAL,F2RL,PHID,FCL800#                                          LF00  13
INTEGER MARK,STEP,SKIP,STOP,DOWN,NREF#                                  LF00  14
INTEGER RFLG,NCOL,NLIN#                                                 LF00  15
INTEGER FAS,MED,SLO,NFMT,NGRP,HEAD,ICOL#                                LF00  16
INTEGER IHKL(3),ITEM(20)#                                               LF00  17
INTEGER NCHR,MODE,NITEM,NSCL,NOUT,MAXR,MREF,LIST,IOFF,IREF#             LF00  18
INTEGER JFMT(22),IFMT(20)#                                              LF00  19
INTEGER I1,I2,IC,IPH,IPUN,LPAK,NDST,NPUN#                               LF00  20
INTEGER IA,IB#                                                          LF00  21
REAL    F2CL,HM,HS#                                                     LF00  22
REAL    SCALE(64),FMT(40)#                                              LF00  23
REAL    A,B,DSNM,H(3),STOL,PSCL(20)#                                    LF00  24
#                                                                       LF00  25
intdata:(LL,18)#                                                        LF00  26
intdata:(IDNM,[1,304,305,820,801,802,300,820,301,302,820,#              LF00  27
303,308,309,202,600,201,200,700,700,204,901,902,903,#                   LF00  28
314,315,312,313])#                                                      LF00  29
realdata:(FOR,[360413.,400413.,440413.,540842.,640842.])#               LF00  30
realdata:(FMA,[513.,513.,513.,513.,513.,513.,513.,513.,513.,513.])#     LF00  31
realdata:(MH,[9999.,9999.,9999.,0.,9999.])#                             LF00  32
chardata:(LF01, OUTPUT FORMAT SCALE  PSCALE MAXHKL END   )#             LF00  33
chardata:(LF02,FMSNFFI)#                                                LF00  34
chardata:(LF03,HKL FRELSIGFFCALACALBCALIRELICALSIGIF2RLF2CL$#           LF00  35
SGF2RCODSCGPEXTFEVALABSFTBARPCYCPDEGRLP WGT1WGT2WGT3$#                  LF00  36
FFREFSIGFF2RFSGF)#                                                      LF00  37
chardata:(LF04,[,LKHHKL])#                                              LF00  38
chardata:(LF05, -****)#                                                 LF00  39
chardata:(LF06, ITEMS TO BE LISTED)#                                    LF00  40
chardata:(LF07, OUTPUT FORMATS ARE)#                                    LF00  41
chardata:(LF08, ITEMS HAVE BEEN SCALED)#                                LF00  42
chardata:(LF09, CHARS/LINE  LINES/PAGE)#                                LF00  43
chardata:(LF10,[ FREL AND SIGF SCALE(S)])#                              LF00  44
chardata:(LF11, LISTFC CONTROL PARAMETERS-)#                            LF00  45
chardata:(LF12, MAX H K L  MIN/MAX STOL)#                               LF00  46
chardata:(LF13,[ RCODE PRINT SIGNALS (      )])#                        LF00  47
chardata:(LF14, ONE OF THE FOLLOWING EXPECTED BDF ITEMS IS MISSING)#    LF00  48
chardata:(LF15,ORD FLA NFL WID LIN DSE IND PUN NPU VBL )#               LF00  49
datastuff:#                                                             LF00  50
#                                                                       LF00  51
#    SET IO BUFFERS                                                     LF00  52
#    --------------                                                     LF00  53
#                                                                       LF00  54
IOMARK(1)=QXSTR#                       Start of buffer for file a       LF00  55
incrqx:(MARK,IOMARK(1)+bdfbuf:,LF0002)# Incr memory.....lf0002          LF00  56
DO I=1,3;  IHKL(I)=0#                  Reset sort order                 LF00  57
DO I=1,20; IFMT(I)=513#                Set default format               LF00  58
DO I=1,20; PSCL(I)=1.#                 Reset default scales             LF00  59
RFLG=no:#                              Switch off rcode flag            LF00  60
IPUN=no:#                              Switch off punch output          LF00  61
NCHR=prtcmax:#                         Default char per line            LF00  62
NLIN=prtlmax:#                         Default lines per page           LF00  63
DSNM=1.#                               Default data set number          LF00  64
MODE=1#                                Default indices is one           LF00  65
PHID=0#                                Phi is in 2pi radians            LF00  66
F2CL=0#                                Not calculaing fcal squared      LF00  67
ICAL=0#                                Not calculaing ical              LF00  68
#                                                                       LF00  69
#    ENTER 'LISTFC' PARAMETERS                                          LF00  70
#    -------------------------                                          LF00  71
#                                                                       LF00  72
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over chrin fields           LF00  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LF00  74
stringlim:(K,I,J)#                     Get string pointers              LF00  75
compchar:(CHRIN,I,LF15,1,3,4,NLF15,N)# Check the list                   LF00  76
IF(N==0) iquit:(LF0001)#               Option not recognised            LF00  77
IF(N==1)#                              Test for sort order              LF00  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LF00  79
K=K+1;  stringlim:(K,I,J)#             Bring in the sorting order       LF00  80
compchar:(CHRIN,I  ,LF04,5,1,1,7,IHKL(3))# Find slow varying index      LF00  81
compchar:(CHRIN,I+1,LF04,5,1,1,7,IHKL(2))# Find med  varying index      LF00  82
compchar:(CHRIN,I+2,LF04,5,1,1,7,IHKL(1))# Find fast varying index      LF00  83
IF(IHKL(1)*IHKL(2)*IHKL(3)==0) iquit:(LF0003)# Not a sort index         LF00  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LF00  85
ELSE IF(N==2)#                         Test for rcode flags             LF00  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LF00  87
RFLG=yes:#                             Switch on the flags              LF00  88
stringlim:(K+1,I,J)#                   Bring in the sorting order       LF00  89
compchar:(CHRIN,I,LF15,1,3,4,NLF15,N)# Check the list                   LF00  90
IF(N>0) NEXT#                          Next field is option             LF00  91
J=MIN0(J-I,4);    K=K+1#               Calculate number supplied        LF00  92
movechar:(CHRIN,I,LF05,2,J,0)#         And replace the defaults         LF00  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LF00  94
ELSE IF(N==4)#                         Test for page width              LF00  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LF00  96
K=K+1#                                 Incr field pointer               LF00  97
ifnm:(BUFIN(K)) NCHR=MIN(mxcout:,NINT(BUFIN(K)))# Width in chars        LF00  98
ELSE            iquit:(LF0004)#        Illegal construction             LF00  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LF00 100
ELSE IF(N==5)#                         Test for lines per page          LF00 101
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LF00 102
K=K+1#                                 Incr field pointer               LF00 103
ifnm:(BUFIN(K)) NLIN=NINT(BUFIN(K))#   Lines per page                   LF00 104
ELSE            iquit:(LF0004)#        Illegal construction             LF00 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LF00 106
ELSE IF(N==6)#                         Test for data set number         LF00 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LF00 108
K=K+1#                                 Incr field pointer               LF00 109
ifnm:(BUFIN(K)) DSNM=BUFIN(K)#         Data set number                  LF00 110
ELSE            iquit:(LF0004)#        Illegal construction             LF00 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LF00 112
ELSE IF(N==7)#                         Test for hkp op mode (1/3)       LF00 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LF00 114
K=K+1#                                 Incr field pointer               LF00 115
ifnm:(BUFIN(K)) MODE=NINT(BUFIN(K))#   Hkl mode                         LF00 116
ELSE            iquit:(LF0004)#        Illegal construction             LF00 117
IF(MODE!=1&MODE!=3) iquit:(LF0006)#    Illegal no. indices              LF00 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LF00 119
ELSE IF(N==8) IPUN=yes:#               Set punch op on                  LF00 120
ELSE IF(N==10)PRVOID=no:#              Set voidflg:s as blank           LF00 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LF00 122
#                                                                       LF00 123
NDST=NINT(DSNM)*1000#                  Make data set offset             LF00 124
ITEM(1)=1;   NITEM=4#                  Default output item hkl          LF00 125
ITEM(2)=NDST+701#                      Default output item frel         LF00 126
ITEM(3)=NDST+800#                      Default output item fcal         LF00 127
ITEM(4)=NDST+305#                      Default output item sigf         LF00 128
IF(MODE==1) DO I=1,3; PSCL(I+1)=10.#   Default scale for fobs, etc.     LF00 129
#                                                                       LF00 130
#   ENTER SCALE INFORMATION LREXPL:                                     LF00 131
#   ------------------------------                                      LF00 132
#                                                                       LF00 133
IWNT(1)=1; IWNT(2)=100; IWNT(3)=12#    Dataset & nscl & sort order      LF00 134
KEY(1)=1; KEY(2)=3; KEY(3)=0; KEY(4)=0# Set search delimiters           LF00 135
indexpkt:(1,lrexpl:,LPAK,IP,0,KEY,IWNT,IREL)# Get packet pointer        LF00 136
NSCL=1;   SCALE(1)=1.#                 Default group & rel pointer      LF00 137
FOR(I=IP+1;I<=IP+LPAK;I=I+1)#          Loop over directory              LF00 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LF00 139
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           LF00 140
J=NINT(QX(I))-100#                     Get group number of scale        LF00 141
SCALE(J)=FLOAT(I-IP)#                  Store relative position          LF00 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LF00 143
REPEAT#                                Loop over data sets              LF00 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LF00 145
readwpkt:(1,lrexpl:,LPAK,IP,0)#        Get packet pointer               LF00 146
IF(IP<=0) BREAK#                       Exit after last packet           LF00 147
I=IP+IREL(1); IF(I==IP) NEXT#          Get index of data set no.        LF00 148
ifne:(DSNM,QX(I)) NEXT#                Skip unwanted data set           LF00 149
I=IP+IREL(2); IF(I>IP) NSCL=NINT(QX(I))# Number of scales               LF00 150
DO I=1,NSCL#                           Loop over scale groups           LF00 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LF00 152
J=IP+NINT(SCALE(I))#                   Point to scale location          LF00 153
IF(J>IP) SCALE(I)=QX(J)#               Store scale in table             LF00 154
ELSE     SCALE(I)=1.#                  Default scale is 1.              LF00 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LF00 156
I=IP+IREL(3); IF(I>IP) ifnv:(QX(I))#   Test if sort order there         LF00 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LF00 158
I=NINT(QX(I)); IHKL(1)=MOD(I,10)#      Get fast index (h=1;k=2;l=3)     LF00 159
IHKL(2)=MOD(I,100)/10; IHKL(3)=I/100#  Get med and fast indices         LF00 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LF00 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LF00 162
DO I=1,3; IF(IHKL(I)==0) iquit:(LF0005)# Sort code is missing           LF00 163
#                                                                       LF00 164
#    ENTER OPTION LINES                                                 LF00 165
#    -------------------                                                LF00 166
#                                                                       LF00 167
REPEAT#                                Loop over input lines            LF00 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LF00 169
readline:(LF01,NLF01)#                 Enter control line               LF00 170
#                                                                       LF00 171
IF(LINID==6) BREAK#                    Exit on end line                 LF00 172
#                                                                       LF00 173
IF(LINID==1)#                          ********* output line            LF00 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LF00 175
FOR(I=1;I<21;I=I+1)#                   Loop over input fields           LF00 176
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LF00 177
ifvo:(BUFIN(I)) BREAK#                 Exit on first void               LF00 178
IF(BUFIN(I)>voidflg:) ITEM(I)=NINT(BUFIN(I))# Store output item         LF00 179
ELSE#                                  Item entered as alpha string     LF00 180
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LF00 181
stringlim:(I,J,K)#                     Get string position              LF00 182
compchar:(CHRIN,J,LF03,1,4,4,NLF03,K)# Search for match                 LF00 183
IF(K==0) iquit:(LF0015)#               No match......lf0015             LF00 184
ITEM(I)=IDNM(K)#                       Store id number                  LF00 185
IF(ITEM(I)!=1) ITEM(I)=ITEM(I)+NDST#   Store id number                  LF00 186
IF    (K== 8)ICAL=I#                   Requesting i cal                 LF00 187
ELSEIF(K==11)F2CL=I#                   Requesting fcal squared          LF00 188
ELSEIF(K==20)PHID=I#                   Requesting phi in degrees        LF00 189
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LF00 190
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LF00 191
NITEM=I-1#                             Store number of items            LF00 192
DO I=1,20; PSCL(I)=1.#                 Reset default scales             LF00 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LF00 194
#                                                                       LF00 195
ELSE IF(LINID==2)#                     ********* format line            LF00 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LF00 197
FOR(I=1;I<21;I=I+1)#                   Loop over input formats          LF00 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 LF00 199
ifvo:(BUFIN(I)) BREAK#                 Exit on first void               LF00 200
IF(BUFIN(I)<voidflg:)#                 For input formats                LF00 201
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 LF00 202
stringlim:(I,J,K)#                     Get string position              LF00 203
compchar:(CHRIN,J,LF02,6,1,1,7,K)#     Search for match                 LF00 204
IF(K==0) iquit:(LF0020)#               Not format......lf0020           LF00 205
IF(K==1) IFMT(I)=02#                   Set f format                     LF00 206
ELSE     IFMT(I)=13#                   Set i format                     LF00 207
movechar:(BLANK,1,CHRIN,J,1,0)#        Blank out f or i                 LF00 208
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 LF00 209
ELSE iquit:(LF0020)#                   Illegal format.....lf0020        LF00 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 LF00 211
IF(I!=NITEM+1) iquit:(LF0025)#         Items format differ...lf0025     LF00 212
dcodefld:#                             Encode line sans f & i           LF00 213
DO I=1,NITEM#                          Loop over fields                 LF00 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 LF00 215
J=NINT(BUFIN(I))#                      Get integer value                LF00 216
K=NINT(BUFIN(I)*10.)-J*10#             Get decimal places               LF00 217
IFMT(I)=J*100+K*10+IFMT(I)#            Construct xtal format            LF00 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 LF00 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LF00 220
#                                                                       LF00 221
ELSE IF(LINID==3)#                     *********** scale line           LF00 222
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 LF00 223
ifnv:(BUFIN(2)) I=NINT(BUFIN(2))#      Extract scale group              LF00 224
ELSE            I=1#                   Default scale group is 1         LF00 225
SCALE(I)=BUFIN(1)#                     Store frel scale                 LF00 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 LF00 227
#                                                                       LF00 228
ELSE IF(LINID==4)#                     ********** pscale line           LF00 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 LF00 230
DO I=1,20#                             Loop over input fields           LF00 231
IF(BUFIN(I)>0.) PSCL(I)=BUFIN(I)#      Store print scale                LF00 232
ELSE            PSCL(I)=1.#            Default print scale is 1         LF00 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 LF00 234
#                                                                       LF00 235
ELSE IF(LINID==5)#                     ************* maxhkl line        LF00 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 LF00 237
DO I=1,5; IF(BUFIN(I)>0.) MH(I)=BUFIN(I)# Transfer active max/min       LF00 238
DO I=1,3; MH(I)=MH(I)+.1#              Protect rounding off             LF00 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 LF00 240
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LF00 241
#                                                                       LF00 242
#    SET UP OUTPUT FORMATS                                              LF00 243
#    ---------------------                                              LF00 244
#                                                                       LF00 245
IPH=0;  LL=0;  NOUT=0;  M=MODE#        Set initial char posns           LF00 246
DO I=1,NITEM#                          Loop over fields                 LF00 247
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 LF00 248
J=IFMT(I)/100#                         Get string width                 LF00 249
DO L=1,M#                              Loop over hkl items              LF00 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 LF00 251
LL=LL+J;   NOUT=NOUT+1#                Incr line length counter         LF00 252
JFMT(NOUT)=LL*10000+IFMT(I)#           Construct xtal format            LF00 253
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 LF00 254
M=1#                                   Reset for all non-hkl items      LF00 255
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 LF00 256
IF(RFLG==yes:)#                        If rcode is output               LF00 257
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 LF00 258
DO I=1,NOUT; IFMT(I)=IFMT(I)+10000#    Move format 1 col                LF00 259
NITEM=NITEM+1#                         Incr number of items             LF00 260
ITEM(NITEM)=NDST+308#                  Store rcode idnum                LF00 261
LL=LL+1#                               Incr column width                LF00 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 LF00 263
LL=LL+2#                               Allow for offset                 LF00 264
#                                                                       LF00 265
#    GET REQUIRED ITEMS FROM LRREFL DIRECTORY                           LF00 266
#    ----------------------------------------                           LF00 267
#                                                                       LF00 268
IWNT(1)=1;        IWNT(2)=NDST+309#    Requested hkl and sclg           LF00 269
IWNT(3)=2;        IWNT(4)=NDST+304#    Requested stl and frel           LF00 270
IWNT(5)=NDST+801; IWNT(6)=NDST+802#    Requested acal and bcal          LF00 271
DO I=2,NITEM;     IWNT(I+5)=ITEM(I)#   Request output items             LF00 272
KEY(1)=1; KEY(2)=NITEM+5; KEY(3)=0; KEY(4)=0# Set search keys           LF00 273
IF(ICAL!=0)#                           Requested i cal                  LF00 274
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 LF00 275
IWNT(NITEM+6)=NDST+204#                Need 1/lp factor                 LF00 276
KEY(2)=KEY(2)+1#                       Require extra item               LF00 277
FCL800=NITEM+7#                        Default fcal is 1800             LF00 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 LF00 279
ELSE FCL800=NITEM+6#                   In case 1820 is not present      LF00 280
DO I=1,FCL800-1;IF(IWNT(I)==NDST+820)# Look for 820 request             LF00 281
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 LF00 282
IWNT(FCL800)=NDST+800#                 Item 800 is optional             LF00 283
KEY(3)=KEY(2)+1#                       Optional items                   LF00 284
BREAK#                                 No need to go on                 LF00 285
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 LF00 286
indexpkt:(1,lrrefl:,NPAK,IP,0,KEY,IWNT,IREL)# Search directory          LF00 287
DO I=2,NITEM#                          Loop over output items           LF00 288
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 LF00 289
IF(MOD(IWNT(I+5),1000)==820&IREL(I+5)==0)# Item 820 is not present      LF00 290
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 LF00 291
ITEM(I+5)=IWNT(FCL800);IREL(I+5)=IREL(FCL800)# Replace with fcal 800    LF00 292
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 LF00 293
IF(MOD(IWNT(I+5),1000)==701&IREL(I+5)==0)# Test for frel n701           LF00 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 LF00 295
ITEM(I)=IWNT(4); IREL(I+5)=IREL(4)#    Replace with frel n304           LF00 296
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 LF00 297
IF(MOD(IWNT(I+5),1000)==700&IREL(I+5)==0)# Test for frel n700           LF00 298
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 LF00 299
IPH=I; IREL(I+5)=IREL(5)#              Replace with frel n801           LF00 300
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 LF00 301
IF(IREL(I+5)!=0) NEXT#                 Skip if item on bdf              LF00 302
DO J=2,NITEM; BUFOT(J)=FLOAT(IWNT(J+5))# Format wanted idnums           LF00 303
ncodefld:(BUFOT,2,CHROT,FMA,NITEM-1)#  Format wanted idnums             LF00 304
writeline:(1,LF14,NLF14,2,3)#          Print error message              LF00 305
iquit:(LF0030)#                        Item not found.....lf0030        LF00 306
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 LF00 307
IR=IREL(1);  IG=IREL(2);  IS=IREL(3)#  Store hkl & sclg pointers        LF00 308
IA=IREL(5);  IB=IREL(6)#               Store acal and bcal pointers ^   LF00 309
IC=NDST+308; I1=NDST+701; I2=NDST+304# Id num of rcode                  LF00 310
#                                                                       LF00 311
#    ARRANGE PAGE LAYOUT                                                LF00 312
#    -------------------                                                LF00 313
#                                                                       LF00 314
NCHR=MAX(NCHR,LL)#                     Ensure large enough i col        LF00 315
NCOL=NCHR/LL#                          Number of columns per line       LF00 316
MAXR=NCOL*(NLIN-2)#                    Max reflections stored           LF00 317
STEP=MAX0(NOUT+RFLG,4)#                Step each stored refl            LF00 318
FAS=IHKL(1); MED=IHKL(2); SLO=IHKL(3)# Store sort order as indices      LF00 319
incrqx:(STOP,MARK+STEP*MAXR,LF0035)#   Get refl buffer....lf0035        LF00 320
NREF=MARK;    MREF=STOP#               Set start/stop refl buffer       LF00 321
HM=-10000.;    HS=-10000.#             Reset last med/slo indices       LF00 322
LIST=NITEM-RFLG;    IOFF=LL/2-5#       List sans rcode & head offse     LF00 323
K=0;    NGRP=1#                        Start item counter in line       LF00 324
DO I=1,NCOL#                           Loop over refl columns           LF00 325
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 LF00 326
L=(I-1)*LL*10000#                      Calc column offset               LF00 327
DO J=1,NOUT#                           Loop over items/refln            LF00 328
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 LF00 329
K=K+1#                                 Incr total item counter          LF00 330
FMT(K)=FLOAT(JFMT(J)+L)#               Construct op format              LF00 331
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 LF00 332
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 LF00 333
#                                                                       LF00 334
#     TELL USER WHAT IS TO BE LISTED                                    LF00 335
#     ------------------------------                                    LF00 336
#                                                                       LF00 337
movechar:(LF11,NLF11,CHROT,2,NLF11-2,1)# Insert underline               LF00 338
writeline:(1,LF11,NLF11-1,2,3)#        Print control header             LF00 339
#                                                                       LF00 340
movechar:(LF06,1,CHROT,1,NLF06,0)#     Insert sub-header                LF00 341
DO I=1,NITEM#                          Loop over output items           LF00 342
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 LF00 343
A=FLOAT(ITEM(I)); B=FLOAT(I*80000+280513)# Float item and format        LF00 344
ncodefld:(A,1,CHROT,B,1)#              Format item                      LF00 345
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 LF00 346
writeline:(0,0,0,1,3)#                 Print item numbers               LF00 347
#                                                                       LF00 348
movechar:(LF07,1,CHROT,1,NLF07,0)#     Insert subheader                 LF00 349
DO I=1,LIST#                           Loop over list items             LF00 350
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 LF00 351
K=MOD(IFMT(I),10)#                     Extract format type              LF00 352
IF(K==2) A=FLOAT(IFMT(I)/10)*.1#       Convert for output               LF00 353
ELSE     A=FLOAT(IFMT(I)/100)#         Convert for output               LF00 354
B=FLOAT(I*80000+280410+K)#             Construct format                 LF00 355
ncodefld:(A,1,CHROT,B,1)#              Format output format             LF00 356
movechar:(LF02,K+4,CHROT,I*8+20+K*2,1,0)# Insert code f or i            LF00 357
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 LF00 358
writeline:(0,0,0,1,3)#                 Print format line                LF00 359
#                                                                       LF00 360
movechar:(LF08,1,CHROT,1,NLF08,0)#     Insert sub-header                LF00 361
DO I=1,LIST#                           Loop over list items             LF00 362
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 LF00 363
B=FLOAT(I*80000+280522)#               Construct format                 LF00 364
ncodefld:(PSCL,I,CHROT,B,1)#           Format output scale              LF00 365
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 LF00 366
writeline:(0,0,0,1,3)#                 Print item numbers               LF00 367
#                                                                       LF00 368
movechar:(LF09,1,CHROT,1,NLF09,0)#     Insert sub-header                LF00 369
ncodefld:(FLOAT(NCHR),1,CHROT,360413.,1)# Format chars per line         LF00 370
ncodefld:(FLOAT(NLIN),1,CHROT,440413.,1)# Format lines per page         LF00 371
writeline:(0,0,0,1,3)#                 Print page parameters            LF00 372
#                                                                       LF00 373
IF(MH(1)<9990.\MH(5)<9990.)#           Test if maxhkl entered           LF00 374
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 LF00 375
movechar:(LF12,1,CHROT,1,NLF12,0)#     Insert sub-header                LF00 376
ncodefld:(MH,1,CHROT,FOR,5)#           Format max/min limits            LF00 377
writeline:(0,0,0,1,3)#                 Print max/min limits             LF00 378
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 LF00 379
#                                                                       LF00 380
movechar:(LF10,1,CHROT,1,NLF10,0)#     Insert sub-header                LF00 381
DO I=1,NSCL#                           Loop over scales                 LF00 382
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 LF00 383
ncodefld:(FLOAT(I),1,CHROT,360213.,1)# Format scale group               LF00 384
ncodefld:(SCALE,I,CHROT,440742.,1)#    Format frel scale                LF00 385
writeline:(0,0,0,1,3)#                 Print frel scale                 LF00 386
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 LF00 387
IF(RFLG==yes:)#                        Test if rcodes are flagged       LF00 388
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 LF00 389
movechar:(LF05,1,LF13,23,NLF05,0)#     Move characters                  LF00 390
writeline:(0,LF13,NLF13,3,3)#          Report them to user              LF00 391
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 LF00 392
writeline:(0,0,0,1,3)#                 Print spacer                     LF00 393
NPUN=MIN(NCHR,80)#                     Set minimum punch line op        LF00 394
#                                                                       LF00 395
#    ENTER LRREFL: BDF RECORDS                                          LF00 396
#    -------------------------                                          LF00 397
#                                                                       LF00 398
REPEAT#                                Loop over lrrefl records         LF00 399
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 LF00 400
readwpkt:(1,lrrefl:,NPAK,IP,0)#        Point to ip packet               LF00 401
#                                                                       LF00 402
IF(IP>0)#                              If refln present in buffer       LF00 403
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 LF00 404
gethkl:(IP+IR,H)#                      Extract h,k,l                    LF00 405
STOL=QX(IP+IS)#                        Extract sin theta/ lambda        LF00 406
IF(H(1)>MH(1)) NEXT#                   Skip if outside limits           LF00 407
IF(H(2)>MH(2)) NEXT#                   Skip if outside limits           LF00 408
IF(H(3)>MH(3)) NEXT#                   Skip if outside limits           LF00 409
IF(STOL<MH(4)) NEXT#                   Skip if outside limits           LF00 410
IF(STOL>MH(5)) NEXT#                   Skip if outside limits           LF00 411
IF(ABS(H(MED)-HM)>.5\ABS(H(SLO)-HS)>.5)# Test if new block              LF00 412
IF(NREF+4*STEP>STOP) MREF=NREF#        Reset end of page                LF00 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 LF00 414
#                                                                       LF00 415
IF(IP<=0\NREF>=MREF)#                  Test if buffer full or end       LF00 416
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 LF00 417
IF(MODE==1)#                           If in publication mode           LF00 418
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 LF00 419
LINCT=0;  writeline:(0,0,0,-1,3)#      Force new page/no header         LF00 420
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 LF00 421
LINCT=100000#                          Prevent normal pagination        LF00 422
SKIP=(((NREF-MARK)/STEP-1)/NCOL+1)*STEP# Get current page length        LF00 423
DOWN=MARK+SKIP#                        Get loop limit                   LF00 424
FOR(N=MARK;N<DOWN;N=N+STEP)#           Loop down lines                  LF00 425
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 LF00 426
HEAD=0;        NFMT=1-NOUT#            Set header & format counter      LF00 427
FOR(M=N;M<NREF;M=M+SKIP)#              Loop along line                  LF00 428
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 LF00 429
HEAD=HEAD+LL;    ICOL=HEAD-IOFF#       Incr hkl header posn             LF00 430
NFMT=NFMT+NOUT#                        Incr item counter                LF00 431
IF(QX(M+1)<(-19999)) NEXT#             Skip blank line                  LF00 432
IF(QX(M+1)<(- 9999))#                  Test for hkl header              LF00 433
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 LF00 434
DO I=2,4#                              Loop over l,k,h words            LF00 435
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 LF00 436
A=QX(M+I)#                             Extract index value              LF00 437
IF(A<(-9999))#                         Test if fast varying index       LF00 438
movechar:(LF04,I,CHROT,ICOL,1,0)#      Insert h,k or l                  LF00 439
ELSE#                                  Else is numeric index            LF00 440
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 LF00 441
B=FLOAT(ICOL*10000)+413.#              Construct format for index       LF00 442
ncodefld:(A,1,CHROT,B,1)#              Format index                     LF00 443
IF(A>  9.5\A<  -.5) ICOL=ICOL-1#       Decr column pointer              LF00 444
IF(A> 99.5\A< -9.5) ICOL=ICOL-1#       Decr column pointer              LF00 445
IF(A>999.5\A<-99.5) ICOL=ICOL-1#       Decr column pointer              LF00 446
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 LF00 447
ICOL=ICOL-1#                           Decr column pointer              LF00 448
IF(I<4) movechar:(LF04,1,CHROT,ICOL,1,0)# Insert comma                  LF00 449
ICOL=ICOL-1#                           Decr column pointer              LF00 450
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 LF00 451
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 LF00 452
#                                                                       LF00 453
ELSE#                                  Else buffer single refln         LF00 454
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 LF00 455
ncodefld:(QX,M+1,CHROT,FMT(NFMT),NOUT)# Format one reflection           LF00 456
IF(RFLG==yes:)#                        Are rcodes marked                LF00 457
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 LF00 458
I=NINT(QX(M+STEP))#                    Extract rcode from list          LF00 459
movechar:(LF05,I,CHROT,HEAD-1,1,0)#    Insert rcode flag                LF00 460
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 LF00 461
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 LF00 462
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 LF00 463
#                                                                       LF00 464
IF(IPUN==yes:) writepch:(CHROT,NPUN)#  Punch reflection data            LF00 465
writeline:(0,0,0,-1,3)#                Print line sans page header      LF00 466
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 LF00 467
#                                                                       LF00 468
IF(IP<=0) BREAK#                       Exit if last reflection          LF00 469
NREF=MARK;  MREF=STOP#                 Reset refn list pointer          LF00 470
FOR(I=MARK;I<STOP;I=I+STEP)#           Loop over refln list             LF00 471
QX(I+1)=-10000.#                       Reset list to blanks             LF00 472
HM=-10000.;    HS=-10000.#             Reset last med/slo indices       LF00 473
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 LF00 474
#                                                                       LF00 475
#    STORE OUTPUT ITEMS                                                 LF00 476
#    ------------------                                                 LF00 477
#                                                                       LF00 478
IF(MODE==1&(ABS(H(MED)-HM)>.5\ABS(H(SLO)-HS)>.5))# Test if new block    LF00 479
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 LF00 480
QX(NREF+1)=-20000.#                    Generate blank line              LF00 481
NREF=NREF+STEP#                        Incr for blank line              LF00 482
QX(NREF+1)=-10000.#                    Flag as hkl header line          LF00 483
QX(NREF+2)=H(3)#                       Store l index                    LF00 484
QX(NREF+3)=H(2)#                       Store k index                    LF00 485
QX(NREF+4)=H(1)#                       Store h index                    LF00 486
QX(NREF-FAS+5)=-10000.#                Mark fast index                  LF00 487
NREF=NREF+STEP#                        Incr for blank line              LF00 488
QX(NREF+1)=-20000.#                    Generate blank line              LF00 489
NREF=NREF+STEP#                        Incr for blank line              LF00 490
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 LF00 491
#                                                                       LF00 492
IF(IG>0) NGRP=NINT(QX(IP+IG))#         Get scale group                  LF00 493
IREF=NREF+MODE-1#                      Set mode offset                  LF00 494
DO I=2,NITEM#                          Loop over output items           LF00 495
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 LF00 496
J=IREF+I;  K=IP+IREL(I+5)#             Point to op and ip               LF00 497
QX(J)=QX(K); L=ITEM(I)#                Store output item                LF00 498
ifvo:(QX(K)) NEXT#                     If the output item is void       LF00 499
IF(L==I1\L==I2\L==I2+1\L==I2+10\L==I2+11)# Test frel/sigf & friedel     LF00 500
QX(J)=QX(J)*SCALE(NGRP)#               Scale frel/sigf values           LF00 501
ELSEIF((L>=I2-4&L<I2)\(L>=I2+6&L<I2+10))# Irel sigi f2rl sgf2           LF00 502
QX(J)=QX(J)*SCALE(NGRP)*SCALE(NGRP)#   Scale f2rel/sigf2 values         LF00 503
IF    (I==ICAL) QX(J)=QX(J)*QX(J)/QX(IP+IREL(NITEM+6))# Fcal^2*rlp      LF00 504
ELSEIF(I==F2CL) QX(J)=QX(J)*QX(J)#     F2cal is fcal^2                  LF00 505
ELSEIF(I==IPH)#                        If phase to be calculated        LF00 506
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 LF00 507
A=QX(K); B=QX(K+1)#                    Extract acal and bcal            LF00 508
QX(J)=MOD(9.+ACOS(A/SQRT(A*A+B*B+.001))/6.283185,1.)# Phi range 0-1.    LF00 509
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 LF00 510
IF(I==PHID)QX(J)=QX(J)*360.#           Convert to degrees               LF00 511
IF(L!=IC) ifnv:(QX(J)) QX(J)=QX(J)*PSCL(I)# Scale all but rcodes        LF00 512
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 LF00 513
HM=H(MED);   HS=H(SLO)#                Store med/slo indices            LF00 514
IF(MODE==3) DO I=1,3; QX(NREF+I)=H(I)# Store all indices                LF00 515
ELSE        QX(NREF+1)=H(FAS)#         Store fast index only            LF00 516
NREF=NREF+STEP#                        Incr storage pointer             LF00 517
100 CONTINUE#                          Skip refln branchpoint           LF00 518
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 LF00 519
IF(MODE==1) LINCT=0#                   Reset page length                LF00 520
readwpkt:(1,endrecord:,I,I,0)#         Finish off input bdf             LF00 521
#                                                                       LF00 522
RETURN#                                                                 LF00 523
END#                                                                    LF00 524
pmacro:([no:])#                        Purge xtal system macros         LF00 525
